#Compile                              Dll "FHGrid9.dll"  'I mostly used PowerBASIC's includes for this, but only a few
#Dim                                  All                'lines need to be changed to use Jose's includes (see code).
%DEBUG                                = 1                'This ActiveX Grid Control compiles to about 48 K as a release
%UNICODE                              = 1                'build, and 91 K as a debug build.  With UPX binary packer the
#If %Def(%UNICODE)                                       '
    Macro ZStr                        = WStringz         'release build can be compacted to 22 K (using PB Includes).
    Macro BStr                        = WString          'The control can at this time only be used if compiled with
    %SIZEOF_CHAR                      = 2                'PowerBASIC Windows 10.01 or 10.02.  PBWin 10.03 builds
#Else
    Macro ZStr                        = Asciiz           'malfunction in various severe ways (they GPF).  I wouldn't
    Macro BStr                        = String           'recommend compiling an Ansi Character Build, i.e., non UNICODE.
    %SIZEOF_CHAR                      = 1                '
#EndIf
#Include Once                         "Win32Api.inc"     'For PowerBASIC Includes
'#Include Once                         "Windows.inc"     'For Jose's Includes
#Include Once                         "ObjBase.inc"
'#Include Once                        "ListViewCtrl.inc" 'For Jose's Includes
'#Include Once                        "HeaderCtrl.inc"   'For Jose's Includes
#Resource                             Typelib, 1, "FHGrid9.tlb"

%IDC_GRID                             = 1400             'There are a number of simpler windows controls out of which the
%IDC_BASE                             = 1499             'grid is created.  The "Base" class is a child of the grid that
%SIZEOF_PTR                           = 4                'became necessary due to a truely miserable and intractable
%SIZEOF_HANDLE                        = 4                'SetWindowPos() problem I was having with the "Pane" class and
%ID_PANE                              = 1500             'the verticle buttons along the left edge of the grid.  The "Pane"
%ID_HEADER                            = 1505             'class is what scrolls horizontally.  Upon it sit the "Cell" objects
%ID_CELL                              = 1600             'which are just simple white windows.  When the user clicks in a cell
%IDC_EDIT                             = 1605             'an edit control is moved over the cell and the parent set to the
%IDC_COMBO                            = 1705             'cell. If a combo box is used in some column it becomes a child of
%MAX_CONNECTIONS                      = 4                'the cell. Maximum number of sinks which can be hooked up to
%GRID_CELL_CTRL_NONE                  = 0                'connection point  Not used yet I don't believe.
%GRID_CELL_CTRL_EDIT                  = 1                'Most typical case, i.e., an edit control set as child of cell.
%GRID_CELL_CTRL_COMBO                 = 2                'Combo Box used as child of cell.
%GRID_CELL_CTRL_CHECK                 = 3                'Not implemented yet.
%CONNECT_E_FIRST                      = &H80040200
%CONNECT_E_ADVISELIMIT                = %CONNECT_E_FIRST+1
%MAX_COLORS                           = 15               'Maximum number of brushes, i.e., colors that can be created.


Declare Function ptrQueryInterface _                     'Model procedure declares for Call Dword need to be created, as this
( _                                                      'control is implemented with low level COM, i.e., it goes 'underneath'
  Byval this                          As Dword Ptr, _    'the PowerBASIC's high level COM implementation.  I don't believe its
  Byref iid                           As Guid, _         'possible to use PowerBASIC's high level COM implementation to create
  Byval pUnknown                      As Dword _         'visible GUI controls, because of limitations of the WithEvents keyword.
) As Long

Declare Function ptrRelease _                            'If it is important for you to understand this code, and you don't, let
( _                                                      'me say it is indeed complicated stuff.  Here is how I learned it.  The
  Byval this                          As Dword Ptr _     'three main books I used were "Indide COM" by Dale Rogerson, "Inside DCOM"
) As Long                                                'by Guy And Henry Eddon, and "Developers Workshop To COM And ATL 3.0" by
                                                         'Andrew W. Troelsen.  Also very noteworthy was "COM In Plain C" by Jeff
Declare Function ptrKeyPress _                           'Glatt.  You can do an internet search for "COM In Plain C" and you should
( _                                                      'be able to locate Jeff's code and tutorial.  In terms of what the
  Byval this                          As Dword Ptr, _    'translations of all that to PowerBASIC look like, I had to rough that out
  Byval iKeyCode                      As Long, _         'myself, and it was hard and long.  My COM Tutorials on Jose Roca's site
  Byval iKeyData                      As Long, _         'give details of that.  It took me years to figure this stuff out, so keep
  Byval iRow                          As Long, _         'that in mind if you are having difficulties.  I might mention that the
  Byval iCol                          As Long, _         '"Inside DCOM" book by Eddon had a great deal of information on Connection
  Byref blnCancel                     As Long _          'Points, which are a difficult topic.
) As Long

Declare Function ptrKeyDown _                            'The reason model declares need to be created for KeyDown, LButtonDown,
( _                                                      'etc., is that calls into the client's Sink need to be made using function
  Byval this                          As Dword Ptr, _    'pointers, or, if you will, in PowerBAIC parlance, the Call Dword syntax.
  Byval iKeyCode                      As Long, _         'You will find  most of that usage or calling apparatus in fnEditSubClass,
  Byval iKeyData                      As Long, _         'which is the sub class of the edit control moved over a "Cell" when the
  Byval iCellRow                      As Long, _         'user LButtonDowns  on a "Cell" object.
  Byval iGridRow                      As Long, _
  Byval iCol                          As Long, _
  Byref blnCancel                     As Long _
) As Long

Declare Function ptrLButtonDown _
( _
  Byval this                          As Dword Ptr, _
  Byval iCellRow                      As Long, _
  Byval iGridRow                      As Long, _
  Byval iCol                          As Long _
) As Long

Declare Function ptrLButtonDblClk _
( _
  Byval this                          As Dword Ptr, _
  Byval iCellRow                      As Long, _
  Byval iGridRow                      As Long, _
  Byval iCol                          As Long _
) As Long

Declare Function ptrPaste _
( _
  Byval this                          As Dword Ptr, _
  Byval iCellRow                      As Long, _
  Byval iGridRow                      As Long, _
  Byval iCol                          As Long _
) As Long

Declare Function ptrRowSelection _
( _
  Byval this                          As Dword Ptr, _
  Byval iRow                          As Long, _
  Byval iAction                       As Long _
) As Long

Declare Function ptrDelete _
( _
  Byval this                          As Dword Ptr, _
  Byval iRow                          As Long _
) As Long

$IID_IUnknown                         = Guid$("{00000000-0000-0000-C000-000000000046}")
$IID_IClassFactory                    = Guid$("{00000001-0000-0000-C000-000000000046}")
$IID_IConnectionPoint                 = Guid$("{B196B286-BAB4-101A-B69C-00AA00341D07}")
$IID_IConnectionPointContainer        = Guid$("{B196B284-BAB4-101A-B69C-00AA00341D07}")
$CLSID_FHGrid                         = Guid$("{20000000-0000-0000-0000-000000000088}")
$IID_IFHGrid                          = Guid$("{20000000-0000-0000-0000-000000000089}")
$IID_IFHGrid_Events                   = Guid$("{20000000-0000-0000-0000-00000000008A}")
$IID_LIBID_FHGrid                     = Guid$("{20000000-0000-0000-0000-00000000008B}")


Type IGridVtbl                                          ' One of these becomes one of the few global variables
  QueryInterface                      As Dword Ptr      ' in this code...
  AddRef                              As Dword Ptr      '
  Release                             As Dword Ptr      ' Global IGrid_Vtbl As IGridVtbl
  CreateGrid                          As Dword Ptr      '
  SetRowCount                         As Dword Ptr      ' The individual variables or in actuality 'members' of
  GetRowCount                         As Dword Ptr      ' this Type get set down in DllMain(), for example ...
  SetData                             As Dword Ptr      '
  GetData                             As Dword Ptr      ' IGrid_Vtbl.QueryInterface = CodePtr(IGrid_QueryInterface)
  FlushData                           As Dword Ptr      ' IGrid_Vtbl.AddRef         = CodePtr(IGrid_AddRef)
  Refresh                             As Dword Ptr      ' IGrid_Vtbl.Release        = CodePtr(IGrid_Release)
  GetVisibleRows                      As Dword Ptr      ' IGrid_Vtbl.CreateGrid     = CodePtr(IGrid_CreateGrid)
  GethGrid                            As Dword Ptr      '
  GethCell                            As Dword Ptr      ' So in that sense you can see that an Interface is really
  GethComboBox                        As Dword Ptr      ' just a block of memory holding addresses or pointers to
  SetCellAttributes                   As Dword Ptr      ' the functions that are called when an object member call
  DeleteRow                           As Dword Ptr      ' is made.  And the Interface pointer itself, or, if you
End Type                                                ' will - VTable pointer, is just a Type holding a lone
                                                        ' pointer to one of the above as seen just left.  It is
Type IGrid                                              ' one of those, i.e., Vtbl pointers, that are returned to
  lpVtbl                              As IGridVtbl Ptr  ' a client as an interface.
End Type


Type IConnectionPointContainerVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  EnumConnectionPoints                As Dword Ptr
  FindConnectionPoint                 As Dword Ptr
End Type

Type IConnectionPointContainer1
  lpVtbl                              As IConnectionPointContainerVtbl Ptr
End Type


Type IConnectionPointVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  GetConnectionInterface              As Dword Ptr
  GetConnectionPointContainer         As Dword Ptr
  Advise                              As Dword Ptr
  Unadvise                            As Dword Ptr
  EnumConnections                     As Dword Ptr
End Type

Type IConnectionPoint1
  lpVtbl                              As IConnectionPointVtbl Ptr
End Type


Type GridData                                           'This object is used to maintain 'state' in the grid control.
  iCtrlID                             As Long           'Each instantiation of a grid object will cause one of these
  hParent                             As Dword          'to be dynamically allocated, and the pointer to the allocated
  hGrid                               As Dword          'storage will be stored at offset zero in the grid object's
  hBase                               As Dword          'WNDCLASSEX::cbWndExtra bytes.  The IGrid Interface has a method
  hPane                               As Dword          'named CreateGrid() implemented in IGrid_CreateGrid(), and it is
  hCtrlInCell                         As Dword          'there where the CreateWindowEx() call is made that starts
  cx                                  As Dword          'construction of the grid.  The actual grid construction code
  cy                                  As Dword          'is largely contained in function fnGridProc_OnCreate(), which
  hHeader                             As Dword          'is the WM_CREATE handler for objects of class "Grid".
  iCols                               As Dword
  iRows                               As Dword          'GridData::pComObj is particularly noteworthy.  GridData, which
  iVisibleRows                        As Dword          'holds mostly GUI specific data, holds this pointer to the COM
  iRowHeight                          As Dword          'specific data of the IGrid Interface.  Likewise, the CGrid object,
  iPaneHeight                         As Dword          'which holds COM specific data relating to the COM plumbing of the
  iEditedCellRow                      As Long           'grid, i.e., the addresses of the various VTables, also stores the
  iEditedRow                          As Long           'hWnd of the grid there in CGrid::hWndCtrl.  In a sense, this is
  iEditedCol                          As Long           'the interface or conduit between these two types of objects created
  pComObj                             As Dword Ptr      'by an instantiation of a grid in a host object.
  pColWidths                          As Dword Ptr
  pCellCtrlTypes                      As Dword Ptr      'iEditedRow refers to the row in the larger grid buffer.
  pCellHandles                        As Dword Ptr      'iEditedCellRow refers only to rows counting from 1 up to iVisibleRows.
  pGridMemory                         As Dword Ptr      'Will be storing ZStr Ptrs here
  pTextColor                          As Dword Ptr      'Will be storing RGB values here
  pBackColor                          As Dword Ptr      'Will be storing HBRUSHs here.  May be zero for default brush.
  pCreatedColors                      As Dword Ptr      'Colors so far asked for by user per grid instance
  pCreatedBrushes                     As Dword Ptr      'Will be storing created HBRUSHs here.  Accumulate them.
  pVButtons                           As Dword Ptr
  pCtrlHdls                           As Dword Ptr      'Another really important variable in GridData is hCtrlInCell.  See
  iSelectionBackColor                 As Long           'my comments in fnCellProc() for that.  But in summary, this member
  iSelectionTextColor                 As Long           'holds a handle to the edit control superimposed over a cell when
  blnRowSelected                      As Long           'the user WM_LBUTTONDOWNs over a cell.  When no cell is active with
  iSelectedRow                        As Long           'an edit control in it, this member is set to zero.  So in that sense
  iFontSize                           As Long           'it acts both as the handle to the edit control, and as a boolean to
  iFontWeight                         As Long           'indicate that a cell is active and being edited.
  hFont                               As Dword
  szFontName                          As ZStr * 28
End Type


Type CGrid                                                                   'This is the 'Class' of the grid, and each
  lpIGridVtbl                         As IGridVtbl Ptr                       'IClassFactory::CreateInstance() call will
  lpICPCVtbl                          As IConnectionPointContainerVtbl Ptr   'cause one of these to be created.  Note one
  lpICPVtbl                           As IConnectionPointVtbl Ptr            'of the members is CGrid::hWndCtrl.  This
  hWndCtrl                            As Dword                               'member will be filled in after a call of the
  pISink                              As Dword Ptr                           'IGrid::CreateGrid member, which represents
  m_cRef                              As Long                                'the Window Grid Control object of a CGrid
End Type                                                                     'instantiation.


Type IGridEventsVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  Grid_OnKeyPress                     As Dword Ptr
  Grid_OnKeyDown                      As Dword Ptr
  Grid_OnLButtonDown                  As Dword Ptr
  Grid_OnLButtonDblClk                As Dword Ptr
  Grid_OnPaste                        As Dword Ptr
  Grid_OnRowSelection                 As Dword Ptr
  Grid_OnDelete                       As Dword Ptr
End Type

Type IGridEvents
  lpVtbl                              As IGridEventsVtbl Ptr
End Type


Type IClassFactoryVtbl
  QueryInterface                      As Dword Ptr
  AddRef                              As Dword Ptr
  Release                             As Dword Ptr
  CreateInstance                      As Dword Ptr
  LockServer                          As Dword Ptr
End Type

Type IClassFactory1
  lpVtbl                              As IClassFactoryVtbl Ptr
End Type

Type WndEventArgs
  wParam                              As Long
  lParam                              As Long
  hWnd                                As Dword
  hInst                               As Dword
End Type

Declare Function FnPtr(wea As WndEventArgs) As Long

Type MessageHandler
  wMessage                            As Long
  dwFnPtr                             As Dword
End Type
Global MsgHdlr()                      As MessageHandler

Macro  dwIdx(r,c)                     = (r-1) * @pGridData.iCols + (c-1)   'Used to relate two dimensional (row,col) grid coordinates
Global CDClassFactory                 As IClassFactory1                    'to a linear address space
Global IClassFactory_Vtbl             As IClassFactoryVtbl
Global IGrid_Vtbl                     As IGridVtbl
Global IConnPointContainer_Vtbl       As IConnectionPointContainerVtbl
Global IConnPoint_Vtbl                As IConnectionPointVtbl
Global g_hModule                      As Dword
Global g_lLocks                       As Long
Global g_lObjs                        As Long
Global g_CtrlId                       As Long
Global fnEditWndProc                  As Dword                             'Used for edit control subclassing

#If %Def(%DEBUG)
Global fp                             As Long
#EndIf


#If %Def(%DEBUG)
Sub Prnt(strLn As BStr)
  Local iLen, iWritten As Long
  Local hStdOutput As Dword
  Local strNew As BStr
  hStdOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  strNew=strLn + $CrLf
  iLen = Len(strNew)
  WriteConsole(hStdOutput, Byval Strptr(strNew), iLen, iWritten, Byval 0)
End Sub
#EndIf

Function IGrid_QueryInterface(ByVal this As IGrid Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "    Entering IGrid_QueryInterface()"
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      #If %Def(%DEBUG)
      Prnt "        Trying To Get IUnknown"
      #EndIf
      Call IGrid_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IGrid_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IFHGrid
      #If %Def(%DEBUG)
      Prnt "      Trying To Get IFHGrid"
      #EndIf
      Call IGrid_AddRef(this)
      @ppv=this
      #If %Def(%DEBUG)
      Prnt "      this = " & Str$(this)
      Prnt "    Leaving IGrid_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IConnectionPointContainer
      #If %Def(%DEBUG)
      Prnt "        Trying To Get IConnectionPointContainer"
      Prnt "        this = " & Str$(this)
      #EndIf
      Incr this
      @ppv=this
      Call IConnectionPointContainer_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IGrid_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IConnectionPoint
      #If %Def(%DEBUG)
      Prnt "        Trying To Get IConnectionPoint"
      Prnt "        this = " & Str$(this)
      #EndIf
      Incr this : Incr this
      @ppv=this
      Call IConnectionPoint_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "        this = " & Str$(this)
      Prnt "      Leaving IGrid_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case Else
      #If %Def(%DEBUG)
      Prnt "        Looking For Something I Ain't Got!"
      Prnt "      Leaving IGrid_QueryInterface()"
      #EndIf
  End Select

  Function=%E_NoInterface
End Function


Function IGrid_AddRef(ByVal this As IGrid Ptr) As Long
  Local pGrid As CGrid Ptr

  #If %Def(%DEBUG)
  Prnt "    Entering IGrid_AddRef()"
  #EndIf
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "      @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << Before"
  #EndIf
  Incr @pGrid.m_cRef
  #If %Def(%DEBUG)
  Prnt "      @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << After"
  Prnt "    Leaving IGrid_AddRef()"
  #EndIf

  IGrid_AddRef=@pGrid.m_cRef
End Function


Function IGrid_Release(ByVal this As IGrid Ptr) As Long
  Local pGrid As CGrid Ptr
  Register i As Long

  #If %Def(%DEBUG)
  Prnt "  Entering IGrid_Release()"
  #EndIf
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "    pGrid         = " & Str$(pGrid)
  Prnt "    @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << Before"
  #EndIf
  Decr @pGrid.m_cRef
  If @pGrid.m_cRef=0 Then
     #If %Def(%DEBUG)
     For i=0 To %MAX_CONNECTIONS-1
       Prnt "    " & Str$(i) & "    " & Str$(Varptr(@pGrid.@pISink[i])) & "    " & Str$(@pGrid.@pISink[i])
     Next i
     #EndIf
     Call DestroyWindow(@pGrid.hWndCtrl)
     Call CoTaskMemFree(Byval @pGrid.pISink)  
     Call CoTaskMemFree(Byval this)           
     Call InterlockedDecrement(g_lObjs)
     #If %Def(%DEBUG)
     Prnt "    @pGrid.m_cRef = 0   << After"
     Prnt "    Grid Was Deleted!"
     Prnt "  Leaving IGrid_Release()"
     #EndIf
     Function=0
  Else
     #If %Def(%DEBUG)
     Prnt "    @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << After"
     Prnt "  Leaving IGrid_Release()"
     #EndIf
     Function=@pGrid.m_cRef
  End If
End Function


Function IGrid_CreateGrid _                            ' This is one of the IGrid Interface methods.  The act of invoking something like
  ( _                                                  ' this in the client ...
    ByVal this                  As IGrid Ptr, _        '
    Byval hContainer            As Long, _             ' pGrid = NewCom "FHGrid8.Grid"
    Byval strSetup              As BStr, _             '
    Byval x                     As Long, _             ' doesn't directly create a visible grid.  What the above statement does is load
    Byval y                     As Long, _             ' the dll and cause all the internal COM related plumbing to be constructed, such
    Byval cx                    As Long, _             ' as creation of virtual function tables, etc. If a call such as the above
    Byval cy                    As Long, _             ' succeeds and a viable pGrid object returned, then a call such as this ...
    Byval iRows                 As Long, _             '
    Byval iCols                 As Long, _             ' pGrid.CreateGrid _
    Byval iRowHt                As Long, _             ' ( _
    Byval iSelectionBackColor   As Long, _             '   Wea.hWnd, _        ' HANLE parent, i.e., client
    Byval iSelectionTextColor   As Long, _             '   strSetup, _        ' Setup String containing grid header text, col widths, etc.
    Byval strFontName           As BStr, _             '   10, _              ' top left
    Byval iFontSize             As Long, _             '   10, _              ' top right
    Byval iFontWeight           As Long _              '   570, _             ' grid width
  )                             As Long                '   141, _             ' grid height
  Local pGridData               As GridData Ptr        '   %NUMBER_ROWS, _    ' number of rows (likely more than visible rows)
  Local hGrid,dwStyle           As Dword               '   %NUMBER_COLUMNS, _ ' number of columns
  Local pGrid                   As CGrid Ptr           '   20, _              ' row height in pixels
  Local gd                      As GridData            '   0, _               ' Row Selection Back Color
                                                       '   0, _               ' Row Selection Text Color
  #If %Def(%DEBUG)                                     '   "Courier New"$$, _ ' Font Name
  Prnt "  Entering IGrid_CreateGrid()"                 '   10, _              ' Font Size
  Prnt "    this                = " & Str$(this)       '   %FW_BOLD _         ' Font Weight
  Prnt "    hContainer          = " & Str$(hContainer) '  )
  Prnt "    strSetup            = " & strSetup         '
  Prnt "    x                   = " & Str$(x)          ' will eventuate in this procedure being called.  The whole thing left with
  Prnt "    y                   = " & Str$(y)          ' Local gd As GridData' is rather nonsense, as I won't use global variables
  Prnt "    cx                  = " & Str$(cx)         ' unless I have to, and so gd is filled out from the parameters of
  Prnt "    cy                  = " & Str$(cy)         ' IGrid_CreateGrid, and the Varptr(gd) passed into the CreateWindowEx()
  Prnt "    iRows               = " & Str$(iRows)      ' lpCreateParams of the aforementioned call.  That is how the parameters of
  Prnt "    iCols               = " & Str$(iCols)      ' IGrid_CreateGrid manage to get into the WM_CREATE handler for the grid object
  Prnt "    iRowHt              = " & Str$(iRowHt)                ' created through the CreateWindowEx() call just below.  Ridiculous,
  Prnt "    iSelectionBackColor = " & Hex$(iSelectionBackColor)   ' I agree.  But I can't help myself!  Also note, not too far below
  Prnt "    iSelectionTextColor = " & Hex$(iSelectionTextColor)   ' this call ...
  Prnt "    strFontName         = " & strFontName                 '
  Prnt "    iFontSize           = " & Str$(iFontSize)             ' hGrid = CreateWindowEx _
  Prnt "    iFontWeight         = " & Str$(iFontWeight)           ' ( _
  #EndIf                                                          '   %WS_EX_OVERLAPPEDWINDOW, _
  dwStyle                       = %WS_CHILD Or %WS_VISIBLE Or _   '   "Grid", _
                                  %WS_HSCROLL Or %WS_VSCROLL      '   Byval Strptr(strSetup), _
  gd.iCols                      = iCols                           '   dwStyle, _
  gd.iRowHeight                 = iRowHt                          '   x, _
  gd.szFontName                 = strFontName                     '   y, _
  gd.iFontSize                  = iFontSize                       '   cx, _
  gd.iFontWeight                = iFontWeight                     '   cy, _
  gd.iRows                      = iRows                           '   hContainer, _
  gd.iSelectionBackColor        = iSelectionBackColor             '   g_CtrlId, _
  gd.iSelectionTextColor        = iSelectionTextColor             '   g_hModule, _
  hGrid=CreateWindowEx _                                          '   Byval Varptr(gd) _
  ( _                                                             ' )
    %WS_EX_OVERLAPPEDWINDOW, _                '
    "Grid", _                                 '  ... which call creates the grid, is this call ...
    Byval Strptr(strSetup), _                 '
    dwStyle, _                                '  pGridData=GetWindowLong(hGrid,0)
    x, _                                      '
    y, _                                      '  The 'state' data for the Window Grid Object is, as has previously been mentioned, a
    cx, _                                     '  GridData object allocated in fnGridProc_OnCreate().  That object becomes available
    cy, _                                     '  here after the CreateWindowEx() call just above (it was allocated there and stored),
    hContainer, _                             '  and more of the fields of it are filled out here.  Note particularly that
    g_CtrlId, _                               '  CGrid::hWndCtrl gets filled out, as well as this ...
    g_hModule, _                              '
    ByVal Varptr(gd) _                        '  @pGridData.pComObj = this
  )                                           '
  #If %Def(%DEBUG)                            '  In this way you can see how connections are set up between two different types of
  Prnt "    hGrid          = " & Str$(hGrid)  '  memory allocations representing the grid, i.e., the memory allocation for COM related
  #EndIf                                      '  infrastructure such as virtual function tables, and for Windows GUI object stuff such
  Incr g_CtrlId                               '  as HANDLE of the grid, HANDLEs of grid cells, etc.
  pGrid=this
  If hGrid=0 Then
     Function=%E_FAIL : Exit Function
  End If
  @pGrid.hWndCtrl=hGrid
  pGridData=GetWindowLong(hGrid,0)
  #If %Def(%DEBUG)
  Prnt "    pGridData      = " & Str$(pGridData)
  #EndIf
  @pGridData.pComObj=this
  If iSelectionBackColor=0 Then                      ' Here is where @pGridData.iSelectionBackColor and @pGridData.iSelectionTextColor
     @pGridData.iSelectionBackColor=%RGB_ROYALBLUE   ' are set.  Note that IGrid_SetCellAttributes is coded specifically to handle this
  End If                                             ' call here where the iRow and iCol parameters are set to zero.  In all other cases
  If iSelectionTextColor=0 Then                      ' where calls are made into that procedure, iRow and iCol will be set to non-zero
     @pGridData.iSelectionTextColor=%RGB_MAROON      ' values to represent the text color and background color the client wants for spme
  End If                                             ' cell.
  Call IGrid_SetCellAttributes(this,0,0,@pGridData.iSelectionBackColor,@pGridData.iSelectionTextColor)
  Call SetFocus(hGrid)
  #If %Def(%DEBUG)
  Prnt "  Leaving IGrid_CreateGrid()" : Prnt ""
  #EndIf

  Function=%S_OK
End Function



Function IGrid_SetRowCount(Byval this As IGrid Ptr, Byval iRowCount As Long, Byval blnForce As Long) As Long
  Local pGridData As GridData Ptr
  Local iSize,blnFree As Long
  Local pGrid As CGrid Ptr
  Local si As SCROLLINFO
  Register i As Long

  pGrid=this
  #If %Def(%DEBUG)
  Print #fp, "  Entering IGrid_SetRowCount()"
  Print #fp,
  Print #fp, "    i         blnFree"
  Print #fp, "    ================="
  #EndIf
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  iSize=@pGridData.iRows * @pGridData.iCols
  For i=0 To iSize - 1
    blnFree=GlobalFree(@pGridData.@pGridMemory[i])
    #If %Def(%DEBUG)
    Print #fp, "    " i, blnFree
    #EndIf
  Next i
  blnFree=GlobalFree(@pGridData.pGridMemory)
  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "     GlobalFree(@pGridData.pGridMemory) = " blnFree
  #EndIf
  blnFree=GlobalFree(@pGridData.pTextColor)
  #If %Def(%DEBUG)
  Print #fp, "     GlobalFree(@pGridData.pTextColor)  = " blnFree
  #EndIf
  blnFree=GlobalFree(@pGridData.pBackColor)
  #If %Def(%DEBUG)
  Print #fp, "     GlobalFree(@pGridData.pBackColor)  = " blnFree
  #EndIf

  'Create New Memory Block                                    ' This is the way its going to have to be!  I lost several days fighting
  If iRowCount < @pGridData.iVisibleRows Then                 ' with the fundamental restructuring of the grid to support a
     #If %Def(%DEBUG)                                         ' pGridData.iRows < pGridData.iVisibleRows, and I can tell you for a fact
     Print #fp, "    Got In Where iRowCount < iVisibleRows"   ' it isn't worth it!!!! At least not for me at this time.  So here I'm just
     #EndIf                                                   ' going to modify the user's iRowCount parameter so that a grid instance
     iRowCount=@pGridData.iVisibleRows+1                      ' will never have an iRows member less than the .iVisibleRows number.  In
     @pGridData.iRows=@pGridData.iVisibleRows+1               ' this way the grid will always have a verticle scrollbar, and I won't have
  End If                                                      ' to deal with funkiness caused by a blank area where the verticle scroll
  iSize=iRowCount * @pGridData.iCols                          ' bar used to be (other funkiness too).  Maybe someday I'll revisit this
  @pGridData.pGridMemory=GlobalAlloc(%GPTR,iSize*%SIZEOF_PTR) ' situation, but I doubt it.
  If @pGridData.pGridMemory Then
     @pGridData.iRows=iRowCount
     si.cbSize=Sizeof(SCROLLINFO)
     si.fMask=%SIF_RANGE Or %SIF_PAGE Or %SIF_POS
     si.nMin=1
     si.nMax=@pGridData.iRows
     si.nPage=@pGridData.iVisibleRows
     si.nPos=1
     Call SetScrollInfo(@pGrid.hWndCtrl,%SB_VERT,si,%TRUE)

     @pGridData.pTextColor=GlobalAlloc(%GPTR,iSize*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData.pTextColor      = " @pGridData.pTextColor
     #EndIf
     If @pGridData.pTextColor=0 Then
        Function=%E_FAIL : Exit Function
     End If
     @pGridData.pBackColor=GlobalAlloc(%GPTR,iSize*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData.pBackColor      = " @pGridData.pBackColor
     #EndIf
     If @pGridData.pBackColor=0 Then
        Function=%E_FAIL : Exit Function
     End If
     #If %Def(%DEBUG)
     Print #fp, "  Leaving IGrid_SetRowCount()"
     Print #fp,
     #EndIf
     Function=%S_OK : Exit Function
  End If
  #If %Def(%DEBUG)
  Print #fp, "  Leaving IGrid_SetRowCount()"
  Print #fp,
  #EndIf

  Function=%E_FAIL
End Function


Function IGrid_GetRowCount(Byval this As IGrid Ptr, Byref iRowCount As Long) As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr
  Local hGrid As Dword

  #If %Def(%DEBUG)
  Print #fp, "    Entering IGrid_GetRowCount()"
  Prnt "Entering IGrid_GetRowCount()"
  #EndIf
  pGrid=this : hGrid=@pGrid.hWndCtrl : pGridData=GetWindowLong(hGrid,0)
  #If %Def(%DEBUG)
  Print #fp, "      pGrid            = " pGrid
  Print #fp, "      hGrid            = " hGrid
  Print #fp, "      pGridData        = " pGridData
  Print #fp, "      @pGridData.iRows = " @pGridData.iRows
  #EndIf
  iRowCount=@pGridData.iRows
  #If %Def(%DEBUG)
  Prnt "  IGrid_GetRowCount() = " & Str$(@pGridData.iRows)
  Prnt "Leaving IGrid_GetRowCount()"
  Print #fp, "  Leaving IGrid_GetRowCount()"
  Print #fp,
  #EndIf

  Function=%S_Ok
End Function


Function IGrid_SetData(Byval this As IGrid Ptr, Byval iRow As Long, Byval iCol As Long, Byval strData As BStr) As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr
  Local pStr As ZStr Ptr
  Local iIndex As Long

  pGrid=this : pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  If iRow <= @pGridData.iRows And iCol <=@pGridData.iCols Then
     If iRow>0 And iCol>0 Then
        iIndex=dwIdx(iRow,iCol)
        pStr=@pGridData.@pGridMemory[iIndex]
        If @pStr<>strData Then
           Call GlobalFree(pStr)
           pStr=GlobalAlloc(%GPTR, (Len(strData)+1)*%SIZEOF_CHAR )
           If pStr Then
              @pStr=strData
              @pGridData.@pGridMemory[iIndex]=pStr
              Function=%S_OK
           Else
              Function=%S_FALSE
           End If
        Else
           Function=%S_OK
        End If
     Else
        Function=%S_FALSE
     End If
  Else
     Function=%S_FALSE
  End If
End Function


Function IGrid_GetData(Byval this As IGrid Ptr, Byval iRow As Long, Byval iCol As Long, Byref strData As BStr) As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr
  Local pZStr As ZStr Ptr
  Local iIndex As Long

  pGrid=this
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  If iRow <= @pGridData.iRows And iRow > 0 Then
     If iCol<=@pGridData.iCols And iCol>0  Then
        iIndex=dwIdx(iRow,iCol)
        pZStr=@pGridData.@pGridMemory[iIndex]
        strData=@pZStr
        Function=%S_OK : Exit Function
     Else
        Function=%E_FAIL : Exit Function
     End If
  Else
     Function=%E_FAIL : Exit Function
  End If
End Function


Function IGrid_FlushData(Byval this As IGrid Ptr) As Long                              ' This is one of the more important procedures in this
  Local pGridData As GridData Ptr                                                      ' grid control.  When the grid was created in
  Local pGrid As CGrid Ptr                                                             ' fnGridProc_OnCreate(), an edit control or combo boxes
  Local pZStr As ZStr Ptr                                                              ' were created for each column of the grid.  They would
  Local strData As BStr                                                                ' not have been visible when the grid first became visible
  Local hGrid As Dword                                                                 ' to the user, because they were not created with the
  Local iLen As Long                                                                   ' WS_VISIBLE style, and they were created with 0,0,0,0

  #If %Def(%DEBUG)
  Print #fp, "    Entering IGrid_FlushData()"                                          ' for their x, y, cx, and cy parameters.  However, if you
  #EndIf
  pGrid=this : hGrid=@pGrid.hWndCtrl : pGridData=GetWindowLong(hGrid,0)
  #If %Def(%DEBUG)
  Print #fp, "      pGrid                  = " pGrid                                   ' examine the code and comments in fnCellProc case
  Print #fp, "      hGrid                  = " hGrid                                   ' WM_LBUTTONDOWN, you'll see that when the user clicks in
  Print #fp, "      pGridData              = " pGridData                               ' a cell, @pGridData.hCtrlInCell is set ...
  Print #fp, "      @pGridData.hCtrlInCell = " @pGridData.hCtrlInCell
  #EndIf
  If @pGridData.hCtrlInCell Then                                                       ' @pGridData.hCtrlInCell=@pGridData.@pCtrlHdls[iCol-1]
     #If %Def(%DEBUG)
     Print #fp, "      Got In Where @pGridData.hCtrlInCell = %True!"                   ' ... and using that as a boolean as well as a hWnd, it
     Print #fp, "      @pGridData.hCtrlInCell              = " @pGridData.hCtrlInCell  ' becomes possibe to extract the text out of that control,
     #EndIf
     iLen=GetWindowTextLength(@pGridData.hCtrlInCell)                                  ' and flush it to the underlying text string buffer. Note
     pZStr=GlobalAlloc(%GPTR,(iLen+1)*%SIZEOF_CHAR)                                    ' that @pGridData.iEditedRow and pGridData.iEditedCol will
     If pZStr Then                                                                     ' be the x / y coordinates of the underlying grid buffer
        Call GetWindowText(@pGridData.hCtrlInCell,Byval pZStr,iLen+1)                  ' where the data from the hCtrlInCell has to go.  Again,
        strData=@pZStr                                                                 ' these values would have been determined in fnCellProc in
        Call IGrid_SetData(this,@pGridData.iEditedRow,@pGridData.iEditedCol,strData)   ' the WM_LBUTTONDOWN case.  Critically important though is
        #If %Def(%DEBUG)
        Print #fp, "      Got To Here!"                                                ' the SetWindowLong() call just left and two lines down
        #EndIf
        Call SetWindowLong(@pGridData.hCtrlInCell,%GWL_WNDPROC,fnEditWndProc)          ' where the subclass is 'taken off' of the edit control,
        Call SetParent(@pGridData.hCtrlInCell,hGrid)                                   ' its parent set back to the grid itself rather than any
        Call SetWindowPos(@pGridData.hCtrlInCell,%HWND_BOTTOM,0,0,0,0,%SWP_HIDEWINDOW) ' cell, its position and size set back to 0,0,0,0, and its
        @pGridData.hCtrlInCell=0                                                       ' Z Order set beneath everything so it becomes not visible.
        Call IGrid_Refresh(this)                                                       ' Then the grid is refreshed so whatever changes the user
     Else                                                                              ' made becomes visible.
        #If %Def(%DEBUG)
        Print #fp, "      Function=%S_FALSE"                                           ' Note that if the user WM_LBUTTONDOWN'ed in some cell, this
        Print #fp, "    Leaving IGrid_FlushData()"                                     ' procedure here is now finished with doing what it has to
        Print #fp,                                                                     ' do, which is simply to get changes in the hCtrlInCell ...
        #EndIf
        Function=%S_FALSE : Exit Function                                              ' ... written to the grid's buffer.
     End If
  End If
  #If %Def(%DEBUG)
  Print #fp, "      Function=%S_OK"
  Print #fp, "    Leaving IGrid_FlushData()"
  Print #fp,
  #EndIf
  Function=%S_OK
End Function


Function IGrid_Refresh(Byval this As IGrid Ptr) As Long
  Local iRows,iCols,iCountCells,iIdx,iReturn As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr
  Local pText As ZStr Ptr
  Local si As SCROLLINFO
  Register i As Long

  pGrid=this
  #If %Def(%DEBUG)
  Print #fp, "  Entering IGrid_Refresh()"
  #EndIf
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  iRows=@pGridData.iVisibleRows
  iCols=@pGridData.iCols
  iCountCells=iRows*iCols
  si.cbSize = sizeof(SCROLLINFO)
  si.fMask=%SIF_POS
  iReturn=GetScrollInfo(@pGrid.hWndCtrl,%SB_VERT,si)
  #If %Def(%DEBUG)
  Print #fp, "    iReturn                 = " iReturn
  Print #fp, "    @pGridData.iVisibleRows = " @pGridData.iVisibleRows
  Print #fp, "    @pGridData.iCols        = " @pGridData.iCols
  Print #fp, "    iCountCells             = " iCountCells
  Print #fp, "    si.nPos                 = " si.nPos
  Print #fp,
  Print #fp, "    i       @pCellHndls[i]  @pGridMem[i]  @pText  @pBackColor[iIdx]  @pTextColor[iIdx]"
  Print #fp, "    =================================================================================="
  #EndIf
  If iReturn Then
     For i=0 To @pGridData.iVisibleRows * @pGridData.iCols - 1
       iIdx=iCols*(si.nPos-1)+i
       Call SetWindowLong(@pGridData.@pCellHandles[i],0,@pGridData.@pGridMemory[iIdx])
       Call SetWindowLong(@pGridData.@pCellHandles[i],8,@pGridData.@pTextColor[iIdx])
       Call SetWindowLong(@pGridData.@pCellHandles[i],12,@pGridData.@pBackColor[iIdx])
       Call InvalidateRect(@pGridData.@pCellHandles[i], Byval %NULL, %TRUE)
       pText=@pGridData.@pGridMemory[i]
       #If %Def(%DEBUG)
       Print #fp, "    " i, @pGridData.@pCellHandles[i], @pGridData.@pGridMemory[i], @pText, Hex$(@pGridData.@pBackColor[iIdx]),Hex$(@pGridData.@pTextColor[iIdx])
       #EndIf
     Next i
     Function=%S_OK
  Else
     Function=%E_FAIL
  End If
  #If %Def(%DEBUG)
  Print #fp, "  Leaving Refresh()"
  Print #fp,
  #EndIf
End Function


Function IGrid_GetVisibleRows(Byval this As IGrid Ptr, Byref iVisibleRows As Long)  As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr

  pGrid=this
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  iVisibleRows=@pGridData.iVisibleRows

  Function=%S_OK
End Function


Function IGrid_GethGrid(Byval this As IGrid Ptr, Byref hGrid As Long)  As Long
  Local pGrid As CGrid Ptr

  pGrid=this
  hGrid=@pGrid.hWndCtrl
  If hGrid Then
     Function=%S_OK
  Else
     Function=%E_FAIL
  End If
End Function


Function IGrid_GethCell(Byval this As IGrid Ptr, Byval iRow As Long, Byval iCol As Long, Byref hCell As Long)  As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr
  Local iIndex As Long

  pGrid=this
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  If iRow <= @pGridData.iRows And iRow > 0 Then
     If iCol<=@pGridData.iCols And iCol>0  Then
        iIndex=dwIdx(iRow,iCol)
        hCell=@pGridData.@pCellHandles[iIndex]
        Function=%S_OK : Exit Function
     End If
  End If
  hCell=0

  Function=%E_FAIL
End Function


Function IGrid_GethComboBox(Byval this As IGrid Ptr, Byval iCol As Long, Byref hComboBox As Long) As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr

  pGrid=this
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  If @pGridData.@pCellCtrlTypes[iCol-1]=%GRID_CELL_CTRL_COMBO Then
     hComboBox=@pGridData.@pCtrlHdls[iCol-1]
     Function=%S_OK
  Else
     Function=%E_FAIL
  End If
End Function


Function IGrid_SetCellAttributes(Byval this As IGrid Ptr, Byval iRow As Long, Byval iCol As Long, Byval iBackColor As Long, Byval iTextColor As Long) As Long
  Local pGridData As GridData Ptr
  Local iIdx,blnFound As Long
  Local pGrid As CGrid Ptr
  Register i As Long

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Entering IGrid_SetCellAttributes()"
  Print #fp, "    this                           = " this
  Print #fp, "    iRow                           = " iRow
  Print #fp, "    iCol                           = " iCol
  Print #fp, "    iBackColor                     = " Hex$(iBackColor)
  Print #fp, "    iTextColor                     = " Hex$(iTextColor)
  #EndIf
  pGrid=this
  pGridData=GetWindowLong(@pGrid.hWndCtrl,0)
  If iRow And iCol Then
     iIdx=dwIdx(iRow,iCol)
     @pGridData.@pTextColor[iIdx] = iTextColor
  Else
     iIdx=0
  End If
  #If %Def(%DEBUG)
  Print #fp, "    @pGridData.iCols               = " @pGridData.iCols
  Print #fp, "    iIdx                           = " iIdx
  Print #fp, "    @pGridData.pTextColor          = " @pGridData.pTextColor
  Print #fp, "    @pGridData.@pTextColor[iIdx]   = " @pGridData.@pTextColor[iIdx]
  Print #fp, "    @pGridData.@pCellHandles[iIdx] = " @pGridData.@pCellHandles[iIdx]
  Print #fp, "    @pGridData.@pCreatedColors[0]  = " @pGridData.@pCreatedColors[0]
  Print #fp, "    @pGridData.@pCreatedBrushes[0] = " @pGridData.@pCreatedBrushes[0]
  Print #fp, "    i         @pGridData.@pCreatedColors[i]            iBackColor"
  Print #fp, "    ============================================================="
  #EndIf

  'pGridMemory                         As Dword Ptr  'Will be storing ZStr Ptrs here
  'pTextColor                          As Dword Ptr  'Will be storing RGB values here, i.e., %Red, %Blue, etc
  'pBackColor                          As Dword Ptr  'Will be storing HBRUSHs here.  May be zero for default brush.
  'pCreatedColors                      As Dword Ptr  'Colors so far asked for by user per grid instance, e.g., %Red, %Yellow, %Blue, etc.
  'pCreatedBrushes                     As Dword Ptr  'Will be storing created HBRUSHs here.  Accumulate them. Numbers such as &HA0556789

  For i=1 To @pGridData.@pCreatedColors[0]
    #If %Def(%DEBUG)
    Print #fp, "    " i, Hex$(@pGridData.@pCreatedColors[i]),,,Hex$(iBackColor)
    #EndIf
    If @pGridData.@pCreatedColors[i]=iBackColor Then
       blnFound=%True : Exit For
    End If
  Next i
  If blnFound Then
     If iRow And iCol Then
        @pGridData.@pBackColor[iIdx] = @pGridData.@pCreatedBrushes[i]
     End If
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    Got In Where blnFound = %True!"
     Print #fp, "    @pGridData.@pCreatedBrushes[i] = " Hex$(@pGridData.@pCreatedBrushes[i])
     #EndIf
  Else
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    Got In Where blnFound = %False!"
     Print #fp, "    @pGridData.@pCreatedBrushes[0] = " @pGridData.@pCreatedBrushes[0] "  << Before"
     #EndIf
     If @pGridData.@pCreatedBrushes[0]<%MAX_COLORS Then          ' Test to see if @pGridData.@pCreatedBrushes[0]
        Incr @pGridData.@pCreatedBrushes[0]                      ' is less than 15, i.e., %MAX_COLORS
        Incr @pGridData.@pCreatedColors[0]
        #If %Def(%DEBUG)
        Print #fp, "    Will Be Able To Create Another Brush!"
        #EndIf
     Else
        Function=%E_FAIL : Exit Function                         ' We've already created 15 brushes
        #If %Def(%DEBUG)
        Print #fp, "    Can't Create Another Brush!"
        Print #fp, "  Leaving IGrid_SetCellAttributes()"
        Print #fp,
        #EndIf
     End If
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData.@pCreatedBrushes[0] = " @pGridData.@pCreatedBrushes[0] "  << After"
     #EndIf
     @pGridData.@pCreatedBrushes[@pGridData.@pCreatedBrushes[0]] = CreateSolidBrush(iBackColor)
     @pGridData.@pCreatedColors[@pGridData.@pCreatedColors[0]]   = iBackColor
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData.@pCreatedBrushes[@pGridData.@pCreatedBrushes[0]] = " @pGridData.@pCreatedBrushes[@pGridData.@pCreatedBrushes[0]]
     Print #fp, "    @pGridData.@pCreatedBrushes[@pGridData.@pCreatedBrushes[0]] = " Hex$(@pGridData.@pCreatedBrushes[@pGridData.@pCreatedBrushes[0]])
     #EndIf
     If iRow And iCol Then
        @pGridData.@pBackColor[iIdx] = @pGridData.@pCreatedBrushes[@pGridData.@pCreatedBrushes[0]]
        #If %Def(%DEBUG)
        Print #fp, "    Have Just Assigned A Newly Created Brush To pBackColor[]"
        Print #fp, "    @pGridData.@pBackColor[iIdx] = " Hex$(@pGridData.@pBackColor[iIdx])
        #EndIf
     End If
  End If
  #If %Def(%DEBUG)
  If iRow And iCol Then
     Print #fp, "    @pGridData.@pTextColor[iIdx]  = " Hex$(@pGridData.@pTextColor[iIdx])
  End If
  Print #fp, "  Leaving IGrid_SetCellAttributes()"
  Print #fp,
  #EndIf

  Function=%S_Ok
End Function


Function IGrid_DeleteRow(ByVal this As IGrid Ptr, Byval iRow As Long) As Long
  Local iStart,iSize,iCols As Long
  Local pGridData As GridData Ptr
  Local pGrid As CGrid Ptr
  Local hGrid As Dword
  Register i As Long

  #If %Def(%DEBUG)
  Prnt "    Entering IGrid_DeleteRow()"
  #EndIf
  pGrid=this
  hGrid=@pGrid.hWndCtrl
  pGridData=GetWindowLong(hGrid,0)
  #If %Def(%DEBUG)
  Prnt "      pGrid     = " & Str$(pGrid)
  Prnt "      hGrid     = " & Str$(hGrid)
  Prnt "      pGridData = " & Str$(pGridData)
  Prnt "      iRow      = " & Str$(iRow)
  #EndIf
  iSize=(@pGridData.iRows-1)*@pGridData.iCols-1
  iStart=dwIdx(iRow,1)
  iCols=@pGridData.iCols
  #If %Def(%DEBUG)
  Prnt "      iSize     = " & Str$(iSize)
  Prnt "      iStart    = " & Str$(iStart)
  Prnt "      iCols     = " & Str$(iCols)
  #EndIf
  For i=iStart To iSize
    @pGridData.@pGridMemory[i] = @pGridData.@pGridMemory[i+iCols]
    @pGridData.@pTextColor[i]  =  @pGridData.@pTextColor[i+iCols]
    @pGridData.@pBackColor[i]  =  @pGridData.@pBackColor[i+iCols]
  Next i
  iStart=dwIdx(@pGridData.iRows,1)
  For i=iStart To iStart+iCols - 1
    @pGridData.@pGridMemory[i] = 0
    @pGridData.@pTextColor[i]  = 0
    @pGridData.@pBackColor[i]  = 0
  Next i
  For i=1 To iCols
    Call IGrid_SetCellAttributes(this,iRow,i,@pGridData.iSelectionBackColor,@pGridData.iSelectionTextColor)
  Next i
  #If %Def(%DEBUG)
  Prnt "    Leaving IGrid_DeleteRow()"
  #EndIf

  Function=%S_Ok
End Function


Function fnEditSubClass(ByVal hEdit As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local hCell,hPane,hBase,hGrid As Dword
  Local pGridData As GridData Ptr
  Local Vtbl,dwPtr As Dword Ptr
  Local hr,blnCancel As Long
  Local pGrid As CGrid Ptr
  Register i As Long

  hCell=GetParent(hEdit) : hPane=GetParent(hCell)
  hBase=GetParent(hPane) : hGrid=GetParent(hBase)
  pGridData=GetWindowLong(hPane,0)
  pGrid=@pGridData.pComObj
  Select Case As Long wMsg
    Case %WM_CHAR
      #If %Def(%DEBUG)
      Print #fp, "    Entering fnEditSubClass"
      Print #fp, "      Got WM_CHAR Message In fnEditSubClass!"
      #EndIf
      For i=0 To %MAX_CONNECTIONS-1
        If @pGrid.@pISink[i] Then
           dwPtr=@pGrid.@pISink[i]
           VTbl=@dwPtr
           Call Dword @Vtbl[3] Using ptrKeyPress(dwPtr, wParam, lParam, @pGridData.iEditedRow, @pGridData.iEditedCol, blnCancel) To hr
           If blnCancel Then
              Exit Function
           End If
        End If
      Next i
      #If %Def(%DEBUG)
      If SUCCEEDED(hr) Then
         Print #fp, "      Call Dword @Vtbl[3] Using ptrKeyPress() Succeeded!"
      End If
      #EndIf
      If wParam=%VK_RETURN Then
         #If %Def(%DEBUG)
         Print #fp, "      Got WM_CHAR Message %VK_RETURN In fnEditSubClass!"
         #EndIf
         Call IGrid_FlushData(pGrid)
         Call IGrid_Refresh(@pGridData.pComObj)
         #If %Def(%DEBUG)
         Print #fp, "    Leaving fnEditSubClass"
         Print #fp,
         #EndIf
         Exit Function
      Else
         @pGridData.hCtrlInCell=hEdit
      End If
      #If %Def(%DEBUG)
      Print #fp, "    Leaving fnEditSubClass"
      Print #fp,
      #EndIf
    Case %WM_KEYDOWN
      #If %Def(%DEBUG)
      Print #fp, "    Entering fnEditSubClass"
      Print #fp, "      Got WM_KEYDOWN Message In fnEditSubClass!"
      #EndIf
      For i=0 To %MAX_CONNECTIONS-1
        If @pGrid.@pISink[i] Then
           dwPtr=@pGrid.@pISink[i]
           VTbl=@dwPtr
           Call Dword @Vtbl[4] Using ptrKeyDown(dwPtr, wParam, lParam, @pGridData.iEditedCellRow, @pGridData.iEditedRow, @pGridData.iEditedCol, blnCancel) To hr
           If blnCancel Then
              Exit Function                                                       'Declare Function ptrKeyDown _
           End If                                                                 '( _
        End If                                                                    '  Byval this As Dword Ptr, _
      Next i                                                                      '  Byval iKeyCode                      As Long, _
      #If %Def(%DEBUG)                                                            '  Byval iKeyData                      As Long, _
      If SUCCEEDED(hr) Then                                                       '  Byval iCellRow                      As Long, _
         Print #fp, "      Call Dword @Vtbl[4] Using ptrKeyDown() Succeeded!"     '  Byval iGridRow                      As Long, _
      End If                                                                      '  Byval iCol                          As Long, _
      Print #fp, "    Leaving fnEditSubClass"                                     '  Byref blnCancel                     As Long _
      Print #fp,                                                                  ') As Long
      #EndIf
    Case %WM_PASTE
      #If %Def(%DEBUG)
      Print #fp, "      Got WM_PASTE Message In fnEditSubClass!"
      #EndIf
      For i=0 To %MAX_CONNECTIONS-1
        If @pGrid.@pISink[i] Then
           dwPtr=@pGrid.@pISink[i]
           VTbl=@dwPtr
           Call Dword @Vtbl[7] Using ptrPaste(dwPtr, @pGridData.iEditedCellRow, @pGridData.iEditedRow, @pGridData.iEditedCol) To hr
        End If
      Next i
      #If %Def(%DEBUG)
      If SUCCEEDED(hr) Then
         Print #fp, "      Call Dword @Vtbl[7] Using ptrPaste() Succeeded!"
      End If
      #EndIf
    Case %WM_LBUTTONDBLCLK
      #If %Def(%DEBUG)
      Print #fp, "      Got %WM_LBUTTONDBLCLK Message In fnEditSubClass!"
      #EndIf
      For i=0 To %MAX_CONNECTIONS-1
        If @pGrid.@pISink[i] Then
           dwPtr=@pGrid.@pISink[i]
           VTbl=@dwPtr
           Call Dword @Vtbl[6] Using ptrLButtonDblClk(dwPtr, @pGridData.iEditedCellRow, @pGridData.iEditedRow, @pGridData.iEditedCol) To hr
        End If
      Next i
      #If %Def(%DEBUG)
      If SUCCEEDED(hr) Then
         Print #fp, "      Call Dword @Vtbl[6] Using ptrPaste() Succeeded!"
      End If
      #EndIf
   End Select

  Function=CallWindowProc(fnEditWndProc,hEdit,wMsg,wParam,lParam)
End Function


Function EnumGridProc _                                        ' The purpose of this code here is to solve a typical grid problem of
( _                                                            ' having an edit control stuck in a grid cell where the text in the
  Byval hWnd As Long, _                                        ' edit control hasn't yet been written to the underlying grid storage,
  Byval lParam As Dword _                                      ' and the user clicks a button or something, and processing occurs
) As Long                                                      ' without the user's new edit being used.  In other words, some way
  If GetClassLong(hWnd,%GCL_WNDPROC)=lParam Then               ' had to be found to guarantee that user edits are immediately written...
     #If %Def(%DEBUG)
     Print #fp, "    Called EnumGridProc() - ", hWnd, lParam
     #EndIf
     Local pGridData As GridData Ptr                           ' ..to the grid's storage when the user clicks elsewhere in the same grid
     pGridData=GetWindowLong(hWnd,0)                           ' as an edit was made, or any other grids on the user's Form.  So this
     Call IGrid_FlushData(@pGridData.pComObj)                  ' code here runs in response to a user's WM_LBUTTONDOWS in any grid on
  End If                                                       ' the Form.  The WM_LBUTTONDOWN will occur in fnCellProc() just below.
  Function=%True                                               ' See Call EnumChildWindows(). The way it works is that the address of
End Function                                                   ' the grid's WndProc is passed into this procedure through the lParam ...


Function fnCellProc _                                          ' ... parameter, and each hWnd generated by the enumerator of the whole
( _                                                            ' parent Form is checked against that WndProc address.  If a match is
  ByVal hCell As Long, _                                       ' made, then we know we'ge found a "Grid" object.  In that case use its
  ByVal wMsg As Long, _                                        ' hWnd to call IGrid_FlushData(), which causes the BSTR data in the edit
  ByVal wParam As Long, _                                      ' control to be written to the grid's storage buffer.
  ByVal lParam As Long _
) As Long                                                      ' Note that the followinf data is stored in the WNDCLASSEX::cbWndExtra
  Select Case As Long wMsg                                     ' bytes of each cell Window ...
    Case %WM_CREATE                                            '
      Call SetWindowLong(hCell,0,%NULL)                        ' Offset     What's Stored There in WNDCLASSEX::cbWndExtra Bytes
      Function=0 : Exit Function                               ' ==============================================================
    Case %WM_LBUTTONDOWN                                       ' 0  -  3    pZStr, i.e., pointer to string data (ZStr) for cell
      Local iCellBufferPos,iGridMemOffset,iRow,iCol,hr As Long ' 4  -  7    hFont, i.e., this was created in fnWndProc_OnCreate
      Local hPane,hBase,hGrid As Dword                         ' 8  - 11    dwColor, i.e., text color, and an RGB value
      Local pGridData As GridData Ptr                          ' 12 - 15    HBrush, and this is a HANDLE
      Local Vtbl,dwPtr As Dword Ptr                            '
      Local si As SCROLLINFO                                   ' Regarding the WM_LBUTTONDOWN processing, when a cell receives one of
      Local pZStr As ZStr Ptr                                  ' those, the first job is to find the Window Handles of all the various
      Local pGrid As CGrid Ptr                                 ' 'Container' objects out of which the grid is constructed.  The "Pane"
      Register i As Long                                       ' is a parent of the "Cell"s, the "Base" is a parent of the "Pane", and
      Register j As Long                                       ' the "Grid" is a parent to the "Base", and, indirectly, to all the others.
                                                               ' Then EnumChildWindows() is called, as described above.
      #If %Def(%DEBUG)
      Print #fp, "  Entering fnCellProc - Case WM_LBUTTONDOWN"
      #EndIf
      hPane=GetParent(hCell)                                   ' The code just below and left is concerned with locating the zero based
      hBase=GetParent(hPane)                                   ' positions and row/col positions in the various buffers maintained in
      hGrid=GetParent(hBase)                                   ' GridData, such as the position of the text buffer where the text for
      pGridData=GetWindowLong(hPane,0)                         ' the cell is held.  Note the For Loop runs through all the cells using...
      #If %Def(%DEBUG)
      Print #fp, "    @pGridData.hCtrlInCell             = " _
      @pGridData.hCtrlInCell
      #EndIf
      Call EnumChildWindows _                                  ' ...row / col notation, and eventually is able to match up the hCell which
      ( _                                                      ' came into this procedure through the parameter list, to the location of
        @pGridData.hParent, _                                  ' the cell handle in the linear address space of the @pGridData.@pCellHandles
        CodePtr(EnumGridProc), _                               ' buffer.  The dwIdx() macro is used for this translation. Then this little
        Byval Codeptr(fnGridProc) _                            ' gem is used to locate the position in the larger memory buffer ...
      )                                                        '
      si.cbSize = sizeof(SCROLLINFO) : si.fMask=%SIF_POS       ' iGridMemOffset = @pGridData.iCols * (si.nPos -1) + iCellBufferPos
      Call GetScrollInfo(hGrid,%SB_VERT,si)                    ' pZStr=@pGridData.@pGridMemory[iGridMemOffset]
      For i=1 To @pGridData.iVisibleRows                       '
        For j=1 To @pGridData.iCols                            ' Then GridData::iEditedRow and GridData::iEditedCol is saved in GridData ...
          iCellBufferPos = dwIdx(i,j)
          If @pGridData.@pCellHandles[iCellBufferPos]=hCell Then
             iGridMemOffset = @pGridData.iCols * (si.nPos -1) + iCellBufferPos
             pZStr=@pGridData.@pGridMemory[iGridMemOffset]
             iRow=i : iCol=j                                   ' ...for the next WM_LBUTTONDOWN the user makes.  This may only become clear
             @pGridData.iEditedCellRow=iRow                    ' to you once you've examined IGrid_FlushData(), where this call is made ...
             @pGridData.iEditedRow=iRow+si.nPos-1              '
             @pGridData.iEditedCol=iCol                        ' Call IGrid_SetData(this, @pGridData.iEditedRow, @pGridData.iEditedCol, strData)
             Exit, Exit                                        '
          End If                                               ' So you see, when the user does a WM_LBUTTONDOWN, a number of complex things
        Next j                                                 ' have to happen.  First, you have to assume that some other cell presently has
      Next i                                                   ' the focus, either in this grid or another instantiation of a grid.  So the...
      #If %Def(%DEBUG)

      Print #fp, "    iCellBufferPos                     = " iCellBufferPos                     ' ...first thing you need to do to deal with
      Print #fp, "    iGridMemOffset                     = " iGridMemOffset                     ' that is run EnumChildWindows() through all
      Print #fp, "    si.nPos                            = " si.nPos                            ' possible grid instantiations to locate a grid
      Print #fp, "    iRow                               = " iRow                               ' that may have an active edit control in it.
      Print #fp, "    iCol                               = " iCol                               ' If one is found with an active edit control in
      Print #fp, "    @pGridData.@pCellCtrlTypes[iCol-1] = " @pGridData.@pCellCtrlTypes[iCol-1] ' it, then GridData::iEditedRow and ::iEditedCol
      #EndIf

      @pGridData.hCtrlInCell=@pGridData.@pCtrlHdls[iCol-1]     ' will identify that situation in that grid, and the text in that control, i.e.,
      Call SetParent(@pGridData.hCtrlInCell,hCell)             ' @GridData.hCtrlInCell, can be extracted with GetWindowText()                             '
      fnEditWndProc=SetWindowLong _                            ' (see IGrid_FlushData), and that text written to the underlying buffer as
      ( _                                                      ' identified in this procedure as ...
        @pGridData.hCtrlInCell, _                              '
        %GWL_WNDPROC, _                                        ' @pGridData.iEditedCellRow  = iRow,
        CodePtr(fnEditSubClass) _                              ' @pGridData.iEditedRow      = iRow + si.nPos-1
      )                                                        ' @pGridData.iEditedCol=iCol = iCol
      If @pGridData.hFont Then                                 '
         Call SendMessage _                                    ' The entity GridData::hCtrlInCell is set when the user LBUTTONDOWNs over a cell,
         ( _                                                   ' and all the possible values are set into the GridData::pCtrlHdls[] buffer, which
           @pGridData.hCtrlInCell, _                           ' buffer had its values set in fnGridProc_OnCreate(), when the grid was
           %WM_SETFONT, _                                      ' constructed.  Note that whatever text was stored in the grid's underlying
           @pGridData.hFont, _                                 ' memory must be located through iGridMemOffset above, and placed in
           %TRUE _                                             ' pGridData.hCtrlInCell so that the user sees that upon clicking in a grid cell...
         )                                                     '
      End If                                                   '               Call SetWindowText(@pGridData.hCtrlInCell,@pZStr)
      If @pGridData.@pCellCtrlTypes[iCol-1]=%GRID_CELL_CTRL_EDIT Then
         Call SetWindowPos _                                   '
         ( _                                                   ' Then the SetWindowPos() function needs to be called to set the position of the
           @pGridData.hCtrlInCell, _                           ' edit control or combo box to top most.  The final bit of work in WM_LBUTTONDOWN
           %HWND_TOP, _                                        ' is to notify the client through its event sink of the WM_LBUTTONDOWN which just
           1, _                                                ' occurred. Of course, we can get the pointer(s) to the client's event sink(s)
           0, _                                                ' through GridData::pComObj and GridData.pISink[]. Then we simply iterate through
           @pGridData.@pColWidths[iCol-1]-2, _                 ' all the connected sinks using Call Dword.
           @pGridData.iRowHeight, _
           %SWP_SHOWWINDOW _                                   ' In thinking over this code now, what I'm thinking a reader of this code might
         )                                                     ' have trouble understanding, is how @pGridData.hCtrlInCell is used both as the
         Call SetWindowText(@pGridData.hCtrlInCell,@pZStr)     ' HANDLE of the edit control superimposed over a cell, and also as a boolean switch
         Call SetFocus(@pGridData.hCtrlInCell)                 ' to let various procedures 'know' there is an active edit control in a grid cell...
         Call SendMessage(@pGridData.hCtrlInCell,%EM_SETSEL,0,-1)
      End If                                                   ' ...that really has to be dealt with if user edits are not to be lost.
      If @pGridData.@pCellCtrlTypes[iCol-1]=%GRID_CELL_CTRL_COMBO Then
         Call SetWindowPos(@pGridData.hCtrlInCell,%HWND_TOP,1,0,@pGridData.@pColWidths[iCol-1]-2,180,%SWP_SHOWWINDOW)
         Call SendMessage(@pGridData.hCtrlInCell,%CB_SETCURSEL,-1,0)
      End If
      pGrid=@pGridData.pComObj                                 ' This code iterates through all the connection points stored and calls
      For i=0 To %MAX_CONNECTIONS-1                            ' back into those connected sinks.
        If @pGrid.@pISink[i] Then
           dwPtr=@pGrid.@pISink[i]
           VTbl=@dwPtr
           Call Dword @Vtbl[5] Using ptrLButtonDown(dwPtr, @pGridData.iEditedCellRow, @pGridData.iEditedRow, @pGridData.iEditedCol) To hr
           #If %Def(%DEBUG)
           Print #fp, "    hGrid = " hGrid
           Print #fp, "    dwPtr = " dwPtr
           Print #fp, "    Vtbl  = " Vtbl
           #EndIf
        End If
      Next i
      #If %Def(%DEBUG)
      Print #fp, "  Leaving fnCellProc - Case WM_LBUTTONDOWN" : Print #fp,
      #EndIf
      Function=0 : Exit Function
    Case %WM_PAINT
      Local hDC,hFont,hTmp,hBrush,hTmpBr,dwColor,iBkMode As Dword
      Local pBuffer As ZStr Ptr
      Local ps As PAINTSTRUCT
      #If %Def(%DEBUG)
      Print #fp, 
      Print #fp, "  Entering fnCellProc - Case WM_PAINT
      #EndIf
      hDC=BeginPaint(hCell,ps)
      pBuffer=GetWindowLong(hCell,0)
      hFont=GetWindowLong(hCell,4)
      dwColor=GetWindowLong(hCell,8)     ' Foreground, i.e., text color - an RGB value?
      hBrush=GetWindowLong(hCell,12)     ' Background, i,e., background color - a HANDLE
      If hFont Then
         hTmp=SelectObject(hDC,hFont)
      End If
      If dwColor Then
         #If %Def(%DEBUG)
         Print #fp, "    Got In Where dwColor Equals Something!  dwColor = " dwColor 
         Call SetTextColor(hDC,dwColor)
         #EndIf
      End If
      If hBrush Then
         #If %Def(%DEBUG)
         Print #fp, "    Got In Where hBrush Equals Something!   hBrush  = " hBrush 
         Call SetTextColor(hDC,dwColor)
         #EndIf
         Local rc As RECT
         hTmpBr=SelectObject(hDC,hBrush)
         Call GetClientRect(hCell,rc)
         Call FillRect(hDC,rc,hBrush)
         Call SelectObject(hDC,hTmpBr)
      End If
      iBkMode=SetBkMode(hDC,%TRANSPARENT)
      Call TextOut(hDC,1,0,@pBuffer,Len(@pBuffer))
      If hFont Then
         hFont=SelectObject(hDC,hTmp)
      End If
      Call SetBkMode(hDC,iBkMode)
      Call EndPaint(hCell,ps)
      #If %Def(%DEBUG)
      Print #fp, "  Leaving fnCellProc - Case WM_PAINT
      Print #fp, 
      #EndIf
      Function=0 : Exit Function
  End Select

  fnCellProc=DefWindowProc(hCell, wMsg, wParam, lParam)
End Function


Function fnPaneProc(ByVal hPane As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local si As SCROLLINFO
  Register i As Long
  Register j As Long

  Select Case As Long wMsg                     ' Basically, all this code here deals with the somewhat complicated situation
    Case %WM_NOTIFY                            ' of the user resizing the columns in the header control.  As you can see, most
      Local pGridData As GridData Ptr          ' of the code is in the HDN_TRACK case.  Note that the 1st thing done is to check
      Local pNotify As HD_NOTIFY Ptr           ' whether @pGridData.hCtrlInCell iz non-zero.  If so, an edit control is active
      Local iPos(),iWidth() As Long            ' somewhere, and the user's text ought to be flushed to grid storage so it isn't
      Local index,iHt,iRange As Long           ' lost.  Then, note that @pGridData.pColWidths is accessed.  When the grid was
      Local iCols As Dword                     ' put together in fnGridProc_OnCreate(), the initial column widths as specified
      pNotify=lParam                           ' by the client in the setup string strSetup were parsed out of it with Parse,
      pGridData=GetWindowLong(hPane,0)         ' and these initial widths were saved in GridData::pColWidths, which is an array
      Select Case As Long @pNotify.hdr.Code    ' of column widths, with the total stored at @pGridData.@pColWidths[iCols].  When
        Case %HDN_TRACK                        ' the user drags a column divider left or right new column data needs to be ...
          #If %Def(%DEBUG)
          Print #fp, "  Entering fnPaneProc() - %HDN_TRACK Case"
          #EndIf
          If @pGridData.hCtrlInCell Then                                   ' ... created for all the columns, and then the cell's
             Call IGrid_FlushData(@pGridData.pComObj)                      ' locations and widths need to all be recalculated and
             Call IGrid_Refresh(@pGridData.pComObj)                        ' redrawn.  That code is below where you see the iPos()
          End If                                                           ' local array dimensioned, and below that a double i, j
          If @pGridData.pColWidths Then                                    ' For Loop which repositions the cells to reflect their
             @pGridData.@pColWidths[@pNotify.iItem]=@pNotify.@pItem.cxy    ' newly adjusted widths and locations, according to the
          End If                                                           ' header control.
          iCols=@pGridData.iCols
          @pGridData.@pColWidths[iCols]=0
          For i=0 To iCols-1
            @pGridData.@pColWidths[iCols]=@pGridData.@pColWidths[iCols]+@pGridData.@pColWidths[i]
          Next i
          si.cbSize = sizeof(SCROLLINFO)
          si.fMask = %SIF_RANGE Or %SIF_PAGE Or %SIF_DISABLENOSCROLL
          si.nMin = 0 : si.nMax=@pGridData.@pColWidths[iCols]
          si.nPage=@pGridData.cx-33
          iRange=si.nMax-si.nMin
          Call SetScrollInfo(@pGridData.hGrid,%SB_HORZ,si,%TRUE)
          If iRange>si.nPage Then   'Original
             Call SetWindowPos(@pGridData.hPane,%HWND_TOP,0,0,@pGridData.@pColWidths[iCols],@pGridData.cy,%SWP_NOMOVE Or %SWP_SHOWWINDOW)
          Else
             Call SetWindowPos(@pGridData.hPane,%HWND_TOP,0,0,@pGridData.@pColWidths[iCols],@pGridData.cy,%SWP_SHOWWINDOW)
          End If
          Call SetWindowPos(@pGridData.hHeader,%HWND_BOTTOM,0,0,@pGridData.@pColWidths[iCols],@pGridData.iRowHeight,%SWP_NOMOVE Or %SWP_SHOWWINDOW)
          #If %Def(%DEBUG)
          Print #fp, "    si.nMin                       = " si.nMin
          Print #fp, "    si.nMax                       = " si.nMax
          Print #fp, "    si.nPage                      = " si.nPage
          Print #fp, "    @pGridData.@pColWidths[iCols] = " @pGridData.@pColWidths[iCols]
          #EndIf
          Redim iPos(iCols) As Long
          For i=1 To iCols-1
            iPos(i)=iPos(i-1)+@pGridData.@pColWidths[i-1]
          Next i
          If @pGridData.pCellHandles Then
             For i=0 To @pGridData.iVisibleRows-1
               For j=0 To iCols-1
                 index=iCols*i+j
                 iHt=@pGridData.iRowHeight
                 Call MoveWindow(@pGridData.@pCellHandles[index], iPos(j), iHt+(i*iHt), @pGridData.@pColWidths[j], iHt, %False)
               Next j
             Next i
             Call InvalidateRect(@pGridData.hGrid,Byval %NULL,%TRUE)
          End If
          Erase iPos()
          #If %Def(%DEBUG)
          Print #fp, "  Leaving fnPaneProc Case" : Print #fp,
          #EndIf
          Function=0
          Exit Function
        Case %HDN_ENDTRACK
          #If %Def(%DEBUG)
          Print #fp, "  Entering fnPaneProc() - %END_TRACK Case"
          #EndIf
          Call InvalidateRect(@pGridData.hGrid,Byval 0,%TRUE)
          #If %Def(%DEBUG)
          Print #fp, "  Leaving %END_TRACK Case"
          #EndIf
          Function=0 : Exit Function
      End Select
      Function=0 : Exit Function
  End Select

  fnPaneProc=DefWindowProc(hPane, wMsg, wParam, lParam)
End Function


Function fnBaseProc(ByVal hBase As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  fnBaseProc=DefWindowProc(hBase, wMsg, wParam, lParam)
End Function


Function fnGridProc_OnCreate(Wea As WndEventArgs) As Long          ' This is the procedure which actually creates the grid.
  Local iEndRectHt,iHalf,iRemainder,iDifference,iNewGridHt As Long ' When this Dll is loaded and DllGetClassObjectImpl() is
  Local iFlds,iHdlCount,iCols,iCtr,iSize As Long                   ' called, the Sub Initialize() is then called too.  This
  Local strParseData(),strFieldData() As BStr                      ' latter Sub registers (RegisterClassEx()) several Window
  Local pGridData1,pGridData2 As GridData Ptr                      ' Classes necessary to the grid's creation, such as the
  Local dwStyle,hButton,hCell,hDC As Dword                         ' "Grid", Class, the "Pane" Class, and the "Cell" Class.
  Local pCreateStruct As CREATESTRUCT Ptr                          ' When a client app holding an IGrid Interface Pointer
  Local szText As ZStr*64                                          ' makes an IGrid::CreateGrid() member call, the function
  Local hdrItem As HDITEM                                          ' IGrid_CreateGrid() is first called, and this latter
  Local strSetup As BStr                                           ' function makes the CreateWindowEx(..., "Grid", ...)
  Local iPos() As Long                                             ' call that triggers invocation of this fnGridProc_OnCreate()
  Register i As Long                                               ' WM_CREATE handler, which constructs the grid.
  Register j As Long                                               
  Local rc As RECT

  #If %Def(%DEBUG)
  Print #fp, "  Entering fnGridProc_OnCreate()"
  #EndIf
  pCreateStruct=Wea.lParam                                 ' A grid consists of many 'child' or subobjects.  For example,
  Wea.hInst=@pCreateStruct.hInstance                       ' there is the "Grid" itself, which is something of a "Container"
  pGridData1=@pCreateStruct.lpCreateParams                 ' object.  Within the "Grid", and as children of the grid, are
  strSetup=@pCreateStruct.@lpszName                        ' the "Base" object, and the "Pane" object.  Then the "Cell"
  Call GetClientRect(Wea.hWnd,rc)                          ' objects become children of the "Pane" object.  It is the "Pane"
  #If %Def(%DEBUG)
  Print #fp, "    %WM_USER                 = " %WM_USER                ' object which is involved in horizontal scrolling.
  Print #fp, "    %WM_APP                  = " %WM_APP                 ' It is the header control, i.e., WC_HEADER, which
  Print #fp, "    hGrid                    = " Wea.hWnd                ' I've used to provide the functionality of resizable
  Print #fp, "    pGridData1               = " pGridData1              ' grid columns.  That control sits atop and becomes a
  Print #fp, "    Wea.hInstance            = " Wea.hInst               ' child of the "Pane". Then the "Cell" objects, each
  Print #fp, "    @pCreateStruct.cx        = " @pCreateStruct.cx       ' of which are created through a CreateWindowEx() call,
  Print #fp, "    @pCreateStruct.cy        = " @pCreateStruct.cy       ' sit underneath the header control, and are also children
  Print #fp, "    rc.Right                 = " rc.Right                ' of the "Pane".  Of course, some of the first real work
  Print #fp, "    rc.Bottom                = " rc.Bottom               ' this procedure does is to determine the sizes of things
  Print #fp, "    @pGridData1.iFontSize    = " @pGridData1.iFontSize   ' and their locations, given the various parameters sent
  Print #fp, "    @pGridData1.iFontWeight  = " @pGridData1.iFontWeight ' in through the parameter list from the client.  After
  Print #fp, "    @pGridData1.szFontName   = " @pGridData1.szFontName  ' that is the necessity of dealing with the setup string
  Print #fp, "    strSetup                 = " strSetup                ' sent in from the client, which contains all the column info.
  #EndIf
  iCols=ParseCount(strSetup,",")
  #If %Def(%DEBUG)
  Print #fp, "    iCols                    = " iCols
  Print #fp, "    @pGridData1.iRows        = " @pGridData1.iRows
  Print #fp, "    @pGridData1.iCols        = " @pGridData1.iCols
  Print #fp, "    @pGridData1.iRowHeight   = " @pGridData1.iRowHeight
  #EndIf
  If iCols<>@pGridData1.iCols Then                 ' In terms of the strSetup parameter, that is a BSTR passed in from the client
     Function=-1 : Exit Function                   ' with a comma delimited format that contains the initial pixel width of the
  End If                                           ' column, the text to display in the header control, the type of control to
  pGridData2=GlobalAlloc(%GPTR,sizeof(GridData))   ' be set in the cell when a user clicks on a cell (at this time only edit controls
  If pGridData2=0 Then                             ' or combo boxes), and whether the text in the header control is left oriented,
     Function=-1 : Exit Function                   ' right oriented, or centered (<:>:^).  The ':' symbol further is used as the
  End If                                           ' delimiter of this information within each comma delimited substring.  Note
  Call SetWindowLong(Wea.hWnd,0,pGridData2)        ' that PowerBASIC's ParseCount / Parse statement functionality is used to seperate
  @pGridData2.iCtrlID=@pCreateStruct.hMenu         ' the substrings and get at this data.  The Parse Statement was broken in PBWin 10,
  @pGridData2.cx=@pCreateStruct.cx                 ' then fixed in update release 10.01.  In PBWin 10.02 it also worked, but was again
  @pGridData2.cy=@pCreateStruct.cy                 ' broken in PBWin 10.03.  This latter situation only applies to unicode builds
  @pGridData2.iCols=iCols                          ' and on Win 2000/XP machines (for whatever reason).  Therefore, I would not
  @pGridData2.iRows=@pGridData1.iRows              ' recommend using this grid if it is going to be built with PBWin 10.03 (unless
  @pGridData2.iRowHeight=@pGridData1.iRowHeight    ' it won't have any chance of being used on Win 2000/XP, where it will fail).
  iNewGridHt=@pCreateStruct.cy
  iHalf=@pGridData2.iRowHeight/2
  iRemainder=rc.Bottom Mod @pGridData2.iRowHeight
  #If %Def(%DEBUG)
  Print #fp, "    iNewGridHt               = " iNewGridHt
  Print #fp, "    @pGridData2.iRowHeight   = " @pGridData2.iRowHeight
  Print #fp, "    iHalf                    = " iHalf
  Print #fp, "    iRemainder               = " iRemainder
  #EndIf
  If iRemainder>=iHalf Then
     iDifference=@pGridData2.iRowHeight-iRemainder
     iEndRectHt=rc.Bottom+(@pGridData2.iRowHeight-iRemainder)
  Else
     iDifference=-iRemainder
     iEndRectHt=rc.Bottom-iRemainder
  End If
  iNewGridHt=iNewGridHt+iDifference
  #If %Def(%DEBUG)
  Print #fp, "    iEndRectHt               = " iEndRectHt
  Print #fp, "    iDifference              = " iDifference
  Print #fp, "    iNewGridHt               = " iNewGridHt
  #EndIf
  @pGridData2.iVisibleRows=Fix((iEndRectHt-@pGridData1.iRowHeight)/@pGridData1.iRowHeight)
  If @pGridData1.iRows>@pGridData2.iVisibleRows Then
     @pGridData2.iRows=@pGridData1.iRows
  Else
     @pGridData2.iRows=@pGridData2.iVisibleRows+1
     @pGridData1.iRows=@pGridData2.iVisibleRows+1
  End If
  @pGridData2.iPaneHeight=(@pGridData2.iVisibleRows+1)*@pGridData1.iRowHeight
  @pGridData2.hGrid=Wea.hWnd
  @pGridData2.hParent=GetParent(Wea.hWnd)
  @pGridData1.iVisibleRows=@pGridData2.iVisibleRows
  #If %Def(%DEBUG)
  Print #fp, "    pGridData2               = " pGridData2
  Print #fp, "    @pGridData2.hParent      = " @pGridData2.hParent
  Print #fp, "    @pGridData2.iCtrlID      = " @pGridData2.iCtrlID
  Print #fp, "    @pGridData2.iPaneHeight  = " @pGridData2.iPaneHeight
  Print #fp, "    @pCreateStruct.cy        = " @pCreateStruct.cy
  Print #fp, "    @pGridData1.iRowHeight   = " @pGridData1.iRowHeight
  Print #fp, "    @pGridData2.iVisibleRows = " @pGridData2.iVisibleRows
  Print #fp, "    @pGridData2.iRows        = " @pGridData2.iRows
  #EndIf
  Redim strParseData(iCols) As BStr
  Parse strSetup,strParseData(),","                                ' Here is the statement that seems to cause memory corruption on
  @pGridData2.pColWidths=GlobalAlloc(%GPTR,(iCols+1)*%SIZEOF_PTR)  ' Win 2000/XP when 10.03 compiler is used.  Note that the only
  If @pGridData2.pColWidths=0 Then                                 ' precondition necessary to trigger the compiler bug is that
     Goto CleanUp                                                  ' Parse be called.  Every other statement in this procedure can
  End If                                                           ' be removed, and in fact, the entirety of the grid code can be
  #If %Def(%DEBUG)
  Print #fp, "    @pGridData2.pColWidths   = " @pGridData2.pColWidths  ' removed, until there is nothing left but a CreateWindowEx
  Print #fp,                                                           ' call in IGrid_CreateGrid().  So what I'm saying is that this
  Print #fp, "    i         strParseData(i) "                          ' code can be stripped down from its present line count of
  Print #fp, "    ============================="                       ' about 3200 lines, down to about 1500 lines, which action
  For i=0 To iCols-1                                                   ' removes the entirety of the grid code, and GPFs will be
    Print #fp, "    " i, strParseData(i)                               ' triggered on 2000/XP machines simply by having the above
  Next i                                                               ' left Parse statement in the code.  It is not even necessary
  Print #fp,                                                           ' to access the Parse results to get crashes.  So, to avoid
  #EndIf                                                               ' problems, do not compile with 10.03!

  @pGridData2.hBase=CreateWindowEx(0,"Base","",%WS_CHILD Or %WS_VISIBLE,0,0,0,0,Wea.hWnd,1499,Wea.hInst,Byval 0)               'Create Base
  dwStyle=%WS_CHILD Or %WS_BORDER Or %WS_VISIBLE Or %HDS_HOTTRACK Or %HDS_HORZ
  @pGridData2.hPane=CreateWindowEx(0,"Pane","",%WS_CHILD Or %WS_VISIBLE,0,0,0,0,@pGridData2.hBase,%ID_PANE,Wea.hInst,Byval 0)  'Create Pane
  @pGridData2.hHeader=CreateWindowEx(0,WC_HEADER,"",dwStyle,0,0,0,0,@pGridData2.hPane,%ID_HEADER,Wea.hInst,Byval 0)            'Create Header Control
  Call SetWindowLong(@pGridData2.hPane,0,pGridData2)

  @pGridData2.pCellCtrlTypes=GlobalAlloc(%GPTR,(iCols)*%SIZEOF_PTR)   'Set up ptr to buffer in GridData for holding control types for column, i.e.,
  If @pGridData2.pCellCtrlTypes=0 Then                                'edit controls, none, combo boxes, etc.
     Goto CleanUp
  End If
  @pGridData2.pCtrlHdls=GlobalAlloc(%GPTR,(iCols)*%SIZEOF_PTR)
  If @pGridData2.pCtrlHdls=0 Then
     Goto CleanUp
  End If

  #If %Def(%DEBUG)
  Print #fp, "    @pGridData2.hBase           = " @pGridData2.hBase
  Print #fp, "    @pGridData2.hPane           = " @pGridData2.hPane
  Print #fp, "    @pGridData2.hHeader         = " @pGridData2.hHeader
  Print #fp, "    @pGridData2.pCellCtrlTypes  = " @pGridData2.pCellCtrlTypes
  Print #fp,
  Print #fp, "    i     @pColWidths[i]     iPos(i)      szText        strFieldData(2),            strFieldData(3)              Cell Ctrl Type"
  Print #fp, "    ==========================================================================================================================="
  #EndIf
  hdrItem.mask=%HDI_FORMAT Or %HDI_WIDTH Or %HDI_TEXT
  Redim iPos(iCols) As Long

  For i=0 To iCols-1                                ' This rather complex code sets up the header control using the data parsed
    iFlds=ParseCount(strParseData(i),":")           ' from the setup string, such as grid column text strings, initial widths,
    Redim strFieldData(iFlds-1)                     ' justification of text in header control, etc.  Note that each of the sub-
    Parse strParseData(i), strFieldData(), ":"      ' strings parsed from the comma delimited setup string needs to be further parsed
    @pGridData2.@pColWidths[i]=Val(strFieldData(0)) ' for the sub - sub-strings within them that use the ':' char as a delimiter.
    @pGridData2.@pColWidths[iCols]=@pGridData2.@pColWidths[iCols]+@pGridData2.@pColWidths[i]   ' The strSetup passed in from the
    hdrItem.cxy=@pGridData2.@pColWidths[i]                              ' client is comma delimited, and those sub-strings went into
    szText=strFieldData(1)                                              ' strParseData().  However, eich strParseData(i) sub-string
    hdrItem.pszText=Varptr(szText) : hdrItem.cchTextMax=Len(szText)     ' contains sub-sub-strings delimited by the ':' symbol.
    If strFieldData(2)="<" Then
       hdrItem.fmt= %HDF_LEFT
    Else
       If strFieldData(2)="^" Then
          hdrItem.fmt=%HDF_CENTER
       Else
          hdrItem.fmt=%HDF_RIGHT
       End If
    End If
    hdrItem.fmt=hdrItem.fmt Or %HDF_STRING
    Call Header_InsertItem(@pGridData2.hHeader,i,Varptr(hdrItem))   ' Use This For PowerBASIC Includes
    'Call Header_InsertItem(@pGridData2.hHeader,i,hdrItem)          ' Use This For Jose Roca Includes
    If i Then
       iPos(i)=iPos(i-1)+@pGridData2.@pColWidths[i-1]
    End If
    Select Case strFieldData(3)
      Case "none"
        @pGridData2.@pCellCtrlTypes[i]=0
      Case "edit"
        @pGridData2.@pCellCtrlTypes[i]=1
      Case "combo"
        @pGridData2.@pCellCtrlTypes[i]=2
      Case "check"
        @pGridData2.@pCellCtrlTypes[i]=3
    End Select
    #If %Def(%DEBUG)
    Print #fp, "   " i, @pGridData2.@pColWidths[i], iPos(i), szText, strFieldData(2), ,strFieldData(3), , @pGridData2.@pCellCtrlTypes[i]
    #EndIf
    Erase strFieldData()
  Next i

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "    i         @pGridData2.@pCtrlHdls[i]"
  Print #fp, "    ==================================="
  #EndIf
  Local blnEditCreated,iCboCtr As Long                             ' GridData::pCellCtrlTypes[] will hold HANDLEs for all the controls
  For i=0 To iCols-1                                               ' such as edit controls or combo boxes which can be set as a child
    If @pGridData2.@pCellCtrlTypes[i]=%GRID_CELL_CTRL_EDIT Then    ' over a cell.  At this time provisions have been made only for edit
       If blnEditCreated=%False Then                               ' controls and combo boxes.  Perhaps in the future I'll add others.
          dwStyle=%WS_CHILD Or %ES_AUTOHSCROLL                     ' When you WM_LBUTTODOWN over a cell, the HANDLE to one of the windows
          @pGridData2.@pCtrlHdls[i]=CreateWindow _                 ' in GridData::pCellCtrlTypes[] will be set into GridData::hCtrlInCell.
          ( _                                                      ' Then when the user clicks on another cell or does something to cause
            "edit", _                                              ' the cell to lose focus, the GridData::hCtrlInCell hWnd will be used
            "", _                                                  ' to extract the text from the superimposed control and write it to
            dwStyle, _                                             ' the underlying Grid's storage, i.e., GridData::pGridMemory.  You
            0, _                                                   ' need to study IGrid_FlushData(), EnumGridProc(), and fnCellProc case
            0, _                                                   ' WM_LBUTTONDOWN to understand all this.  The blnEditCreated boolean
            0, _                                                   ' is used to ensure that only one edit control is created, as one will
            0, _                                                   ' be enough.  In the case of combo boxes though, a unique one must be
            Wea.hWnd, _                                            ' created for each column the client wants to put one in.
            %IDC_EDIT, _
            Wea.hInst, _
            ByVal 0 _
          )
          @pGridData2.hCtrlInCell=@pGridData2.@pCtrlHdls[i]
          blnEditCreated=%True
       Else
          @pGridData2.@pCtrlHdls[i]=@pGridData2.hCtrlInCell
       End If
    End If
    If @pGridData2.@pCellCtrlTypes[i]=%GRID_CELL_CTRL_COMBO Then
       dwStyle=%WS_CHILD Or %CBS_DROPDOWNLIST Or %WS_VSCROLL 'Or %CBS_NOINTEGRALHEIGHT
       @pGridData2.@pCtrlHdls[i]=CreateWindow("combobox","",dwStyle,0,0,0,0,Wea.hWnd,%IDC_COMBO+iCboCtr,Wea.hInst,ByVal 0)
       Incr iCboCtr
    End If
    #If %Def(%DEBUG)
    Print #fp, "   " i, @pGridData2.@pCtrlHdls[i]
    #EndIf
  Next i
  @pGridData2.hCtrlInCell=0

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "    @pGridData2.@pColWidths[iCols]   = " @pGridData2.@pColWidths[iCols]
  Print #fp,
  #EndIf
  Call MoveWindow(Wea.hWnd,@pCreateStruct.x,@pCreateStruct.y,@pCreateStruct.cx,iNewGridHt,%FALSE)
  Call MoveWindow(@pGridData2.hBase,12,0,rc.right-12,@pGridData2.iPaneHeight,%FALSE)
  Call MoveWindow(@pGridData2.hPane,0,0,@pGridData2.@pColWidths[iCols],@pGridData2.iPaneHeight,%FALSE)  'Size Pane
  Call MoveWindow(@pGridData2.hHeader,0,0,@pGridData2.@pColWidths[iCols],@pGridData2.iRowHeight,%TRUE)  'Size Header

  'Make Verticle Buttons that go at far left in the grid, and which can be clicked to select a grid row
  @pGridData2.pVButtons=GlobalAlloc(%GPTR,(@pGridData2.iVisibleRows+1)*%SIZEOF_PTR)
  #If %Def(%DEBUG)
  Print #fp, "    @pGridData2.pVButtons = " @pGridData2.pVButtons
  Print #fp,
  Print #fp, "   i          @pGridData2.@pVButtons[i] "
  Print #fp, "   ====================================="
  #EndIf
  If @pGridData2.pVButtons Then
     For i=0 To @pGridData2.iVisibleRows
       @pGridData2.@pVButtons[i]=CreateWindow("button","",%WS_CHILD Or %WS_VISIBLE Or %BS_FLAT,0,@pGridData2.iRowHeight*i,12,@pGridData2.iRowHeight,Wea.hWnd,20000+i,Wea.hInst,Byval 0)
       #If %Def(%DEBUG)
       Print #fp, "   " i, @pGridData2.@pVButtons[i]
       #EndIf
     Next i
  Else
     Goto CleanUp
  End If

  'Try To Create Font  ' ANSI_CHARSET  '%OEM_CHARSET
  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "    Now Gonna Try To Create Font..."
  Print #fp, "    @pGridData1.szFontName = " @pGridData1.szFontName
  #EndIf
  If @pGridData1.szFontName<>"" Then
     hDC=GetDC(Wea.hWnd)
     @pGridData2.hFont=CreateFont _
     ( _
       -1*(@pGridData1.iFontSize*GetDeviceCaps(hDC,%LOGPIXELSY))/72, _
       0, _
       0, _
       0, _
       @pGridData1.iFontWeight, _
       0, _
       0, _
       0, _
       %ANSI_CHARSET, _
       0, _
       0, _
       %DEFAULT_QUALITY, _
       0, _
       @pGridData1.szFontName _
     )
     Call ReleaseDC(Wea.hWnd,hDC)
  End If
  #If %Def(%DEBUG)
  Print #fp, "    @pGridData2.hFont      = " @pGridData2.hFont
  #EndIf

  'Try To Make Grid Cells, i.e., "Cell" Class
  iHdlCount=@pGridData2.iCols*@pGridData2.iVisibleRows
  @pGridData2.pCellHandles=GlobalAlloc(%GPTR, iHdlCount * %SIZEOF_HANDLE)
  If @pGridData2.pCellHandles Then
     dwStyle=%WS_CHILD Or %WS_VISIBLE Or %WS_BORDER
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    i          j             iPos(j)       yLoc          hCell"
     Print #fp, "    ============================================================="
     #EndIf
     For i=0 To @pGridData2.iVisibleRows-1
       For j=0 To @pGridData2.iCols-1
         hCell=CreateWindowEx _
         ( _
           0, _
           "Cell", _
           "", _
           dwStyle, _
           iPos(j), _
           @pGridData2.iRowHeight+(i*@pGridData2.iRowHeight), _
           @pGridData2.@pColWidths[j], _
           @pGridData2.iRowHeight, _
           @pGridData2.hPane, _
           %ID_CELL+iCtr, _
           Wea.hInst, _
           Byval 0 _
         )
         @pGridData2.@pCellHandles[iCtr]=hCell
         Call SetWindowLong(hCell,4,@pGridData2.hFont)
         #If %Def(%DEBUG)
         Print #fp, "   " i, j, iPos(j), @pGridData2.iRowHeight+(i*@pGridData2.iRowHeight), hCell
         #EndIf
         Incr iCtr
       Next j
     Next i

     'Create Grid Memory
     iSize = @pGridData2.iCols * @pGridData2.iRows
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    Now Will Try To Create Grid Row Memory!"
     Print #fp,
     Print #fp, "    iSize                       = " iSize
     #EndIf
     @pGridData2.pGridMemory=GlobalAlloc(%GPTR,iSize*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData2.pGridMemory     = " @pGridData2.pGridMemory
     #EndIf
     @pGridData2.pTextColor=GlobalAlloc(%GPTR,iSize*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData2.pTextColor      = " @pGridData2.pTextColor
     #EndIf
     If @pGridData2.pTextColor=0 Then
        Goto Cleanup
     End If
     @pGridData2.pBackColor=GlobalAlloc(%GPTR,iSize*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData2.pBackColor      = " @pGridData2.pBackColor
     #EndIf
     If @pGridData2.pBackColor=0 Then
        Goto Cleanup
     End If
     @pGridData2.pCreatedColors=GlobalAlloc(%GPTR,(%MAX_COLORS+1)*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData2.pCreatedColors  = " @pGridData2.pCreatedColors
     #EndIf
     If @pGridData2.pCreatedColors=0 Then
        Goto Cleanup
     End If
     @pGridData2.pCreatedBrushes=GlobalAlloc(%GPTR,(%MAX_COLORS+1)*%SIZEOF_PTR)
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData2.pCreatedBrushes = " @pGridData2.pCreatedBrushes
     #EndIf
     If @pGridData2.pCreatedBrushes=0 Then
        Goto Cleanup
     End If
  Else
     Goto CleanUp
  End If
  Erase strParseData()
  Erase iPos()
  #If %Def(%DEBUG)
  Print #fp, "    @pGridData2.hCtrlInCell     = " @pGridData2.hCtrlInCell
  Print #fp, "  Leaving %WM_CREATE Case" : Print #fp,
  #EndIf
  Function=0 : Exit Function

  CleanUp:
  If @pGridData2.pColWidths Then
     Call GlobalFree(@pGridData2.pColWidths)
  End If
  If @pGridData2.pCellCtrlTypes Then
     Call GlobalFree(@pGridData2.pCellCtrlTypes)
  End If
  If @pGridData2.pCtrlHdls Then
     Call GlobalFree(@pGridData2.pCtrlHdls)
  End If
  If @pGridData2.pVButtons Then
     Call GlobalFree(@pGridData2.pVButtons)
  End If
  If @pGridData2.pCellHandles Then
     Call GlobalFree(@pGridData2.pCellHandles)
  End If
  If @pGridData2.pGridMemory Then
     Call GlobalFree(@pGridData2.pGridMemory)
  End If
  If @pGridData2.pTextColor Then
     Call GlobalFree(@pGridData2.pTextColor)
  End If
  If @pGridData2.pBackColor Then
     Call GlobalFree(@pGridData2.pBackColor)
  End If
  If @pGridData2.pCreatedColors Then
     Call GlobalFree(@pGridData2.pCreatedColors)
  End If
  If @pGridData2.pCreatedBrushes Then
     Call GlobalFree(@pGridData2.pCreatedBrushes)
  End If
  If pGridData2 Then
     Call GlobalFree(pGridData2)
  End If
  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Leaving %WM_CREATE Case" : Print #fp,
  #EndIf

  Function=-1
End Function


Function fnGridProc_OnSize(Wea As WndEventArgs) As Long
  Local pGridData As GridData Ptr
  Local si As SCROLLINFO
  Local iCols As Long

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Entering %WM_SIZE Case"
  #EndIf
  pGridData=GetWindowLong(Wea.hWnd,0)
  iCols=@pGridData.iCols

  'Set Up Horizontal Scrollbar
  si.cbSize=Sizeof(SCROLLINFO)
  si.fMask=%SIF_RANGE Or %SIF_PAGE Or %SIF_POS Or %SIF_DISABLENOSCROLL  'This code here caused me a lot of    
  si.nMin=0                                                             'problems.  I had originally missed
  si.nMax=@pGridData.@pColWidths[iCols]                                 'adding the %SIF_DISABLENOSCROLL to
  si.nPage=@pGridData.cx-33 '33 is the width of vert                    'the SCROLLINFO::fMask, and if the
  si.nPos=0                 'btns + width scroll bar + window edge      'grid was instantiated with column
  Call SetScrollInfo(Wea.hWnd,%SB_HORZ,si,%TRUE)                        'widths such that a horizontal
  #If %Def(%DEBUG)                                                      'scroll bar wasn't needed, but then
  Print #fp, "    Horizontal Scrollbar...."                             'the user used the header control to
  Print #fp, "    si.nMin    = " si.nMin                                'widen the columns such that it became
  Print #fp, "    si.nMax    = " si.nMax                                'needed, then it wouldn't show up.
  Print #fp, "    si.nPos    = " si.nPos
  #EndIf

  'Set Up Verticle Scrollbar
  si.cbSize=Sizeof(SCROLLINFO)
  si.fMask=%SIF_RANGE Or %SIF_PAGE Or %SIF_POS
  si.nMin=1
  si.nMax=@pGridData.iRows
  si.nPage=@pGridData.iVisibleRows
  si.nPos=1
  Call SetScrollInfo(Wea.hWnd,%SB_VERT,si,%TRUE)
  #If %Def(%DEBUG)
  Print #fp, "    Verticle Scrollbar...."
  Print #fp, "    si.nMin    = " si.nMin
  Print #fp, "    si.nMax    = " si.nMax
  Print #fp, "    si.nPos    = " si.nPos
  Print #fp, "  Leaving %WM_SIZE Case" : Print #fp,
  #EndIf

  fnGridProc_OnSize=0
End Function


Function fnGridProc_OnHScroll(Wea As WndEventArgs) As Long
  Local pGridData As GridData Ptr
  Local iCols,iScrollPos As Long
  Local si As SCROLLINFO

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Entering %WM_HSCROLL Case"
  #EndIf
  pGridData=GetWindowLong(Wea.hWnd,0)
  iCols=@pGridData.iCols
  si.cbSize = sizeof(SCROLLINFO)   : si.fMask=%SIF_ALL
  Call GetScrollInfo(@pGridData.hGrid,%SB_HORZ,si)
  iScrollPos=si.nPos
  #If %Def(%DEBUG)
  Print #fp, "    Before Adjustments"
  Print #fp, "    si.nMin    = " si.nMin
  Print #fp, "    si.nMax    = " si.nMax
  Print #fp, "    si.nPos    = " si.nPos
  Print #fp,
  #EndIf
  Select Case As Long Lowrd(Wea.wParam)
    Case %SB_LINELEFT
      #If %Def(%DEBUG)
      Print #fp, "    Got In %SB_LINELEFT"
      #EndIf
      If si.nPos > si.nMin Then
         si.nPos=si.nPos-50
      End If
    Case %SB_PAGELEFT
      si.nPos = si.nPos - si.nPage
    Case %SB_LINERIGHT
      #If %Def(%DEBUG)
      Print #fp, "    Got In %SB_LINERIGHT"
      #EndIf
      If si.nPos<si.nMax Then
         si.nPos=si.nPos+50
      End If
    Case %SB_PAGERIGHT
      si.nPos = si.nPos + si.nPage
    Case %SB_THUMBTRACK
      si.nPos=si.nTrackPos
  End Select
  si.fMask=%SIF_POS
  Call SetScrollInfo(@pGridData.hGrid,%SB_HORZ,si,%TRUE)
  Call GetScrollInfo(@pGridData.hGrid,%SB_HORZ,si)
  If iScrollPos<>si.nPos Then   'Original
     If si.nPos=0 Then
        Call SetWindowPos(@pGridData.hPane,%HWND_TOP,0,0,@pGridData.@pColWidths[iCols],@pGridData.iPaneHeight,%SWP_SHOWWINDOW)
     Else
        Call SetWindowPos(@pGridData.hPane,%HWND_TOP,-si.nPos,0,@pGridData.@pColWidths[iCols],@pGridData.iPaneHeight,%SWP_SHOWWINDOW)
     End If
  End If
  #If %Def(%DEBUG)
  Print #fp, "    After All Adjustments"
  Print #fp, "    si.nMin    = " si.nMin
  Print #fp, "    si.nMax    = " si.nMax
  Print #fp, "    si.nPos    = " si.nPos
  Print #fp, "  Leaving %WM_HSCROLL Case"
  #EndIf

  fnGridProc_OnHScroll=0
End Function


Function fnGridProc_OnVScroll(Wea As WndEventArgs) As Long
  Local pGridData As GridData Ptr
  Local iScrollPos As Long
  Local si As SCROLLINFO
  Local hCell As Dword
  Register i As Long

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Entering %WM_VSCROLL Case"
  #EndIf
  pGridData=GetWindowLong(Wea.hWnd,0)
  Call IGrid_FlushData(@pGridData.pComObj)
  si.cbSize = sizeof(SCROLLINFO)   : si.fMask=%SIF_ALL
  Call GetScrollInfo(@pGridData.hGrid,%SB_VERT,si)
  iScrollPos=si.nPos
  #If %Def(%DEBUG)
  Print #fp, "    Before Adjustments"
  Print #fp, "    si.nMin    = " si.nMin
  Print #fp, "    si.nMax    = " si.nMax
  Print #fp, "    si.nPos    = " si.nPos
  Print #fp,
  #EndIf
  Select Case As Long Lowrd(Wea.wParam)
    Case %SB_LINEUP
      #If %Def(%DEBUG)
      Print #fp, "    Got In %SB_LINEUP"
      #EndIf
      If si.nPos > si.nMin Then
         si.nPos=si.nPos-1
      End If
    Case %SB_PAGEUP
      si.nPos = si.nPos - si.nPage
    Case %SB_LINEDOWN
      #If %Def(%DEBUG)
      Print #fp, "    Got In %SB_LINEDOWN"
      #EndIf
      If si.nPos<si.nMax Then
         si.nPos=si.nPos+1
      End If
    Case %SB_PAGEDOWN
      si.nPos = si.nPos + si.nPage
    Case %SB_THUMBTRACK
      si.nPos=si.nTrackPos
  End Select
  si.fMask=%SIF_POS
  Call SetScrollInfo(@pGridData.hGrid,%SB_VERT,si,%TRUE)
  Call GetScrollInfo(@pGridData.hGrid,%SB_VERT,si)
  If iScrollPos<>si.nPos Then
     Local iNum,iLast As Long
     iNum=@pGridData.iCols*(si.nPos-1)
     iLast=(@pGridData.iCols * @pGridData.iVisibleRows) - 1
     For i=0 To iLast
       hCell=@pGridData.@pCellHandles[i]
       Call SetWindowLong(hCell,0,@pGridData.@pGridMemory[iNum])
       Call SetWindowLong(hCell,8,@pGridData.@pTextColor[iNum])
       Call SetWindowLong(hCell,12,@pGridData.@pBackColor[iNum])
       Incr iNum
     Next i
  End If
  Call InvalidateRect(@pGridData.hGrid,Byval %NULL,%TRUE)
  #If %Def(%DEBUG)
  Print #fp, "    After All Adjustments"
  Print #fp, "    si.nMin    = " si.nMin
  Print #fp, "    si.nMax    = " si.nMax
  Print #fp, "    si.nPos    = " si.nPos
  Print #fp, "  Leaving %WM_VSCROLL Case"
  #EndIf

  fnGridProc_OnVScroll=0
End Function


Function fnGridProc_OnCommand(Wea As WndEventArgs) As Long
  Local iCellRow,iGridRow,hr As Long
  Local pGridData As GridData Ptr
  Local Vtbl,dwPtr As Dword Ptr
  Local pGrid As CGrid Ptr
  Local si As SCROLLINFO
  Register i As Long

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Entering fnGridProc_OnCommand()"
  Prnt ""
  Prnt "Entering fnGridProc_OnCommand()"
  Print #fp, "    Lowrd(Wea.wParam) = " Lowrd(Wea.wParam)
  #EndIf
  If Lowrd(Wea.wParam)>20000 Then
     pGridData=GetWindowLong(Wea.hWnd,0)
     pGrid=@pGridData.pComObj
     #If %Def(%DEBUG)
     Prnt "  pGridData          = " & Str$(pGridData)
     Prnt "  @pGridData.pComObj = " & Str$(@pGridData.pComObj)
     Prnt "  pGrid              = " & Str$(pGrid)
     Prnt ""
     Prnt "  i     pGrid.@pISink[i]  @pGrid.@pISink[i]"
     Prnt "  ========================================="
     For i=0 To %MAX_CONNECTIONS-1
       Prnt " " & Str$(i) & "    " & Str$(Varptr(@pGrid.@pISink[i])) & "              " & Str$(@pGrid.@pISink[i])
     Next i
     #EndIf
     Call IGrid_FlushData(@pGridData.pComObj)
     si.cbSize = sizeof(SCROLLINFO)
     si.fMask=%SIF_POS
     Call GetScrollInfo(@pGridData.hGrid,%SB_VERT,si)
     iCellRow=Lowrd(Wea.wParam)-20000
     iGridRow=si.nPos+iCellRow-1
     #If %Def(%DEBUG)
     Prnt "  Lowrd(Wea.wParam) = " & Str$(Lowrd(Wea.wParam))
     Prnt "  iGridRow          = " & Str$(iGridRow)
     #endIf
     If @pGridData.blnRowSelected Then
        #If %Def(%DEBUG)
        Print #fp, "  We Got In Where @pGridData.blnSelected = %True!"
        Prnt "  We Got In Where @pGridData.blnSelected = %True!"
        #EndIf
        If iGridRow=@pGridData.iSelectedRow Then    'Same button clicked twice, i.e., toggled, or user wishes to unselect a row
           #If %Def(%DEBUG)
           Print #fp, "  We Got In Where iGridRow = @pGridData.iSelectedRow!"
           Prnt "  We Got In Where iGridRow = @pGridData.iSelectedRow!"
           #EndIf
           For i=1 To @pGridData.iCols
             Call IGrid_SetCellAttributes(@pGridData.pComObj,@pGridData.iSelectedRow,i,&H00FFFFFF,0)       '''Here
           Next i
           @pGridData.iSelectedRow=0 : @pGridData.blnRowSelected=%False
        Else
           #If %Def(%DEBUG)
           Print #fp, "  We Got In Where iGridRow <> @pGridData.iSelectedRow!"
           Prnt "  We Got In Where iGridRow <> @pGridData.iSelectedRow!"
           #EndIf
           For i=1 To @pGridData.iCols
             Call IGrid_SetCellAttributes(@pGridData.pComObj,@pGridData.iSelectedRow,i,&H00FFFFFF,0)        '''Here
           Next i
           @pGridData.iSelectedRow=iGridRow
           For i=1 To @pGridData.iCols
             Call IGrid_SetCellAttributes(@pGridData.pComObj,iGridRow,i,@pGridData.iSelectionBackColor,@pGridData.iSelectionTextColor) '''Here
           Next i
        End If
     Else
        #If %Def(%DEBUG)
        Prnt "  We Got In Where @pGridData.blnSelected = %False!"
        Print #fp, "  We Got In Where @pGridData.blnSelected = %False!"
        Print #fp, "  @pGridData.iSelectionBackColor         = " Hex$(@pGridData.iSelectionBackColor)
        Print #fp, "  @pGridData.iSelectionTextColor         = " Hex$(@pGridData.iSelectionTextColor)
        #EndIf
        For i=1 To @pGridData.iCols
          'Call IGrid_SetCellAttributes(@pGridData.pComObj,iGridRow,i,%Red,%White)                            '''Here
          Call IGrid_SetCellAttributes(@pGridData.pComObj,iGridRow,i,@pGridData.iSelectionBackColor,@pGridData.iSelectionTextColor)
        Next i
        @pGridData.blnRowSelected=%True
        @pGridData.iSelectedRow=iGridRow
        #If %Def(%DEBUG)
           Prnt "  @pGridData.iSelectedRow   = " & Str$(@pGridData.iSelectedRow)
           Prnt "  @pGridData.blnRowSelected = " & Str$(@pGridData.blnRowSelected)
        #EndIf
     End If
     Call IGrid_Refresh(@pGridData.pComObj)
     'Declare Function ptrRowSelection(Byval this As Dword Ptr, Byval iRow As Long, Byval iAction As Long) As Long
     For i=0 To %MAX_CONNECTIONS-1
        If @pGrid.@pISink[i] Then
           dwPtr=@pGrid.@pISink[i]
           VTbl=@dwPtr
           Call Dword @Vtbl[8] Using ptrRowSelection(dwPtr, iGridRow, @pGridData.blnRowSelected) To hr
           #If %Def(%DEBUG)
           If SUCCEEDED(hr) Then
              Prnt "  Call Dword @Vtbl[8] Using ptrRowSelection() Succeeded!"
              Prnt "  @pGridData.blnRowSelected = " & Str$(@pGridData.blnRowSelected)
           End If
           #EndIf
        End If
      Next i
      Call SetFocus(Wea.hWnd)
  End If
  #If %Def(%DEBUG)
  Print #fp, "  Leaving fnGridProc_OnCommand()"
  Prnt "Leaving fnGridProc_OnCommand()"
  Prnt ""
  Print #fp,
  #EndIf

  Function=0
End Function


Function fnGridProc_OnKeyDown(Wea As WndEventArgs) As Long
  Local pGridData As GridData Ptr
  Local dwPtr,VTbl As Dword Ptr
  Local pGrid As CGrid Ptr
  Register i As Long
  Local hr As Long

  If Wea.wParam=%VK_DELETE Then
     pGridData=GetWindowLong(Wea.hWnd,0)
     pGrid=@pGridData.pComObj
     #If %Def(%DEBUG)
     Prnt "Entering fnGridProc_OnKeyDown()"
     #EndIf
     If @pGridData.blnRowSelected=%True Then
        #If %Def(%DEBUG)
        Prnt "  A Row Is Selected!  The Selected Row Is " & Str$(@pGridData.iSelectedRow)
        #EndIf
        For i=0 To %MAX_CONNECTIONS-1
          If @pGrid.@pISink[i] Then
             dwPtr=@pGrid.@pISink[i]
             VTbl=@dwPtr
             Call Dword @Vtbl[9] Using ptrDelete(dwPtr, @pGridData.iSelectedRow) To hr
          End If
        Next i
        Call IGrid_Refresh(@pGridData.pComObj)
     Else
        #If %Def(%DEBUG)
        Prnt "  No Row Is Selected!"
        #EndIf
     End If
     #If %Def(%DEBUG)
     Prnt "Leaving fnGridProc_OnKeyDown()"
     #EndIf
  End If

  Function=0
End Function


Function fnGridProc_OnDestroy(Wea As WndEventArgs) As Long
  Local pGridData As GridData Ptr
  Local blnFree,iCtr As Long
  Local pMem As ZStr Ptr
  Register i As Long
  Register j As Long

  #If %Def(%DEBUG)
  Print #fp,
  Print #fp, "  Entering fnGridProc_OnDestroy()"
  #EndIf
  pGridData=GetWindowLong(Wea.hWnd,0)
  If pGridData Then
     #If %Def(%DEBUG)
     Print #fp, "    @pGridData.iCols           = " @pGridData.iCols
     Print #fp, "    @pGridData.iRows           = " @pGridData.iRows
     Print #fp, "    @pGridData.pColWidths      = " @pGridData.pColWidths
     Print #fp, "    @pGridData.pCellCtrlTypes  = " @pGridData.pCellCtrlTypes

     'Grid Row Memory
     Print #fp,
     Print #fp, "     i         j            iCtr          strCoordinate                 pMem       pBackColor[i]   pTextColor[i]"
     Print #fp, "    ============================================================================================================"
     iCtr=0
     For i=1 To @pGridData.iRows
       For j=1 To @pGridData.iCols
         pMem=@pGridData.@pGridMemory[iCtr]
         Print #fp, "    " i,j,iCtr,@pMem Tab(72) pMem, Hex$(@pGridData.@pBackColor[iCtr]), Hex$(@pGridData.@pTextColor[iCtr])
         Incr iCtr
        Next j
     Next i
     #EndIf

     blnFree=GlobalFree(@pGridData.pColWidths)
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    blnFree(pColWidths)        = " blnFree
     #EndIf

     If @pGridData.pCellCtrlTypes Then
        blnFree=GlobalFree(@pGridData.pCellCtrlTypes)
        #If %Def(%DEBUG)
        Print #fp, "    blnFree(pCellCtrlTypes)    = " blnFree
        #EndIf
     End If

     If @pGridData.pCtrlHdls Then
        blnFree=GlobalFree(@pGridData.pCtrlHdls)
        #If %Def(%DEBUG)
        Print #fp, "    blnFree(pCtrlHdls)         = " blnFree
        #EndIf
     End If

     If @pGridData.hFont Then
        blnFree=DeleteObject(@pGridData.hFont)
        #If %Def(%DEBUG)
        Print #fp, "    blnFree(hFont)             = " blnFree
        #EndIf
     End If

     #If %Def(%DEBUG)
         Print #fp,
         Print #fp,
         Print #fp, "     i         j            iCtr        blnFree"
         Print #fp, "    ==========================================="
     #EndIf
     iCtr=0
     For i=1 To @pGridData.iRows
       For j=1 To @pGridData.iCols
         pMem=@pGridData.@pGridMemory[iCtr]
         If pMem Then
            blnFree=GlobalFree(pMem)
            #If %Def(%DEBUG)
                Print #fp, "    " i,j,iCtr,blnFree
            #EndIf
         End If
         Incr iCtr
        Next j
     Next i

     blnFree=GlobalFree(@pGridData.pTextColor)
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    blnFree(@pGridData.pTextColor)      = " blnFree
     #EndIf
     blnFree=GlobalFree(@pGridData.pBackColor)
     #If %Def(%DEBUG)
     Print #fp, "    blnFree(@pGridData.pBackColor)      = " blnFree
     #EndIf

     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    @pGridData.@pCreatedBrushes[0]      = " @pGridData.@pCreatedBrushes[0]
     Print #fp, "    @pGridData.@pCreatedColors[0]       = " @pGridData.@pCreatedColors[0]
     Print #fp,
     Print #fp, "    i          DeleteObject(i)"
     Print #fp, "    =========================="
     #EndIf
     For i=1 To @pGridData.@pCreatedBrushes[0]
       If @pGridData.@pCreatedBrushes[i] Then
          blnFree=DeleteObject(@pGridData.@pCreatedBrushes[i])
          #If %Def(%DEBUG)
          Print #fp, "    " i, blnFree
          #EndIf
       End If
     Next i
     blnFree=GlobalFree(@pGridData.pCreatedColors)
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    blnFree(@pGridData.pCreatedColors)  = " blnFree
     #EndIf

     blnFree=GlobalFree(@pGridData.pCreatedBrushes)
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    blnFree(@pGridData.pCreatedBrushes) = " blnFree
     #EndIf

     blnFree=GlobalFree(@pGridData.pGridMemory)
     #If %Def(%DEBUG)
     Print #fp,
     Print #fp, "    blnFree(@pGridData.pGridMemory)     = " blnFree
     #EndIf
     blnFree = GlobalFree(pGridData)
     #If %Def(%DEBUG)
     Print #fp, "    blnFree                             = " blnFree
     #EndIf
  End If
  #If %Def(%DEBUG)
  Print #fp, "  Leaving fnGridProc_OnDestroy()"
  #EndIf

  Function=0
End Function


Function fnGridProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 6
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnGridProc=iReturn
       Exit Function
    End If
  Next i

  fnGridProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Sub AttachMessageHandlers()
  ReDim MsgHdlr(6) As MessageHandler   'Associate Windows Message With Message Handlers
  MsgHdlr(3).wMessage=%WM_CREATE   :   MsgHdlr(3).dwFnPtr=CodePtr(fnGridProc_OnCreate)
  MsgHdlr(2).wMessage=%WM_SIZE     :   MsgHdlr(2).dwFnPtr=CodePtr(fnGridProc_OnSize)
  MsgHdlr(1).wMessage=%WM_HSCROLL  :   MsgHdlr(1).dwFnPtr=CodePtr(fnGridProc_OnHScroll)
  MsgHdlr(0).wMessage=%WM_VSCROLL  :   MsgHdlr(0).dwFnPtr=CodePtr(fnGridProc_OnVScroll)
  MsgHdlr(6).wMessage=%WM_KEYDOWN  :   MsgHdlr(6).dwFnPtr=CodePtr(fnGridProc_OnKeyDown)
  MsgHdlr(5).wMessage=%WM_COMMAND  :   MsgHdlr(5).dwFnPtr=CodePtr(fnGridProc_OnCommand)
  MsgHdlr(4).wMessage=%WM_DESTROY  :   MsgHdlr(4).dwFnPtr=CodePtr(fnGridProc_OnDestroy)
End Sub


Sub Initialize()
  Local uCC As INIT_COMMON_CONTROLSEX
  Local szClassName As ZStr*16
  Local wc As WNDCLASSEX

  #If %Def(%DEBUG)
      Prnt "    Entering Initialize() -- Initialize()"
  #EndIf
  uCC.dwSize = SizeOf(uCC)
  uCC.dwICC  = %ICC_LISTVIEW_CLASSES
  Call InitCommonControlsEx(uCC)
  Call AttachMessageHandlers()

  szClassName="Cell"
  wc.lpszClassName=VarPtr(szClassName)             : wc.lpfnWndProc=CodePtr(fnCellProc)
  wc.cbSize=SizeOf(wc)                             : wc.style=0
  wc.cbClsExtra=0                                  : wc.cbWndExtra=16
  wc.hInstance=g_hModule                           : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)   : wc.hbrBackground=GetStockObject(%WHITE_BRUSH)
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)

  szClassName="Pane"
  wc.lpszClassName=VarPtr(szClassName)             : wc.lpfnWndProc=CodePtr(fnPaneProc)
  wc.cbSize=SizeOf(wc)                             : wc.style=0
  wc.cbClsExtra=0                                  : wc.cbWndExtra=4
  wc.hInstance=g_hModule                           : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)   : wc.hbrBackground=GetStockObject(%WHITE_BRUSH)
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)

  szClassName="Base"
  wc.lpszClassName=VarPtr(szClassName)             : wc.lpfnWndProc=CodePtr(fnBaseProc)
  wc.cbSize=SizeOf(wc)                             : wc.style=0
  wc.cbClsExtra=0                                  : wc.cbWndExtra=0
  wc.hInstance=g_hModule                           : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)   : wc.hbrBackground=GetStockObject(%GRAY_BRUSH)
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)

  szClassName="Grid"
  wc.lpszClassName=VarPtr(szClassName)             : wc.lpfnWndProc=CodePtr(fnGridProc)
  wc.cbSize=SizeOf(wc)                             : wc.style=0
  wc.cbClsExtra=0                                  : wc.cbWndExtra=4
  wc.hInstance=g_hModule                           : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)   : wc.hbrBackground=GetStockObject(%DKGRAY_BRUSH)
  wc.lpszMenuName=%NULL
  #If %Def(%DEBUG)
  Prnt "      GetModuleHandle()        = " & Str$(wc.hInstance)
  #EndIf
  Call RegisterClassEx(wc)
  #If %Def(%DEBUG)
      Prnt "    Leaving Initialize()"
  #EndIf
End Sub


Function IConnectionPointContainer_QueryInterface(ByVal this As IConnectionPointContainer1 Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "    Entering IConnectionPointContainer_QueryInterface()"
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IUnknown"
      #EndIf
      Decr this : @ppv=this
      Call IGrid_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "    Leaving IConnectionPointContainer_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IFHGrid
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IFJHGrid"
      #EndIf
      Decr this : @ppv=this
      Call IGrid_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "    Leaving IConnectionPointContainer_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IConnectionPointContainer
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IConnectionPointContainer"
      #EndIf
      Call IConnectionPointContainer_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "    Leaving IConnectionPointContainer_QueryInterface()"
      #EndIf
      @ppv=this : Function=%S_OK : Exit Function
    Case $IID_IConnectionPoint
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IConnectionPoint"
      #EndIf
      Incr this : @ppv=this
      Call IConnectionPoint_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "    Leaving IConnectionPointContainer_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case Else
      #If %Def(%DEBUG)
      Prnt "        Looking For Something I Ain't Got!"
      Prnt "      Leaving IConnectionPointContainer_QueryInterface()"
      #EndIf
  End Select

  Function=%E_NOINTERFACE
End Function


Function IConnectionPointContainer_AddRef(ByVal this As IConnectionPointContainer1 Ptr) As Long
  Local pGrid As CGrid Ptr

  #If %Def(%DEBUG)
  Prnt "    Entering IConnectionPointContainer_AddRef()"
  #EndIf
  Decr this
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "      @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << Before"
  #EndIf
  Incr @pGrid.m_cRef
  #If %Def(%DEBUG)
  Prnt "      @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << After"
  Prnt "    Leaving IConnectionPointContainer_AddRef()"
  #EndIf

  Function=@pGrid.m_cRef
End Function


Function IConnectionPointContainer_Release(ByVal this As IConnectionPointContainer1 Ptr) As Long
  Local pGrid As CGrid Ptr
  Register i As Long

  #If %Def(%DEBUG)
  Prnt "  Entering IConnectionPointContainer_Release()"
  #EndIf
  Decr this : pGrid=this
  #If %Def(%DEBUG)
  Prnt "    @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << Before"
  #EndIf
  Decr @pGrid.m_cRef
  If @pGrid.m_cRef=0 Then
     #If %Def(%DEBUG)
     For i=0 To %MAX_CONNECTIONS-1
       Prnt "    " & Str$(i) & "    " & Str$(Varptr(@pGrid.@pISink[i])) & "    " & Str$(@pGrid.@pISink[i])
     Next i
     #EndIf
     Call DestroyWindow(@pGrid.hWndCtrl)
     #If %Def(%DEBUG)
     Prnt "    @pGrid.m_cRef = 0 And Will Now Delete pGrid!"
     #EndIf
     Call CoTaskMemFree(Byval @pGrid.pISink)  ' Or, Less Insane ... Call CoTaskMemFree(Byval @pGrid.pISink)
     Call CoTaskMemFree(Byval this)           ' Or, Less Insane ... Call CoTaskMemFree(Byval this)
     Call InterlockedDecrement(g_lObjs)
     Function=0
  Else
     #If %Def(%DEBUG)
     Prnt "    @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << After"
     #EndIf
     Function=@pGrid.m_cRef
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving IConnectionPointContainer_Release()"
  #EndIf
End Function


Function IConnectionPointContainer_EnumConnectionPoints(ByVal this As Dword, Byval ppEnum As Dword) As Long
  Function=%E_NOTIMPL
End Function


Function IConnectionPointContainer_FindConnectionPoint(ByVal this As IConnectionPointContainer1 Ptr, ByRef iid As Guid, ByVal ppCP As Dword Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "  Entering IConnectionPointContainer_FindConnectionPoint()"
  #EndIf
  If iid=$IID_IFHGrid_Events Then
     #If %Def(%DEBUG)
     Prnt "    this  = " & Str$(this)
     Prnt "    @ppCP = " & Str$(@ppCP)
     #EndIf
     Function=IConnectionPointContainer_QueryInterface(this, $IID_IConnectionPoint, ppCP)
     #If %Def(%DEBUG)
     Prnt "    @ppCP = " & Str$(@ppCP)
     Prnt "  Leaving IConnectionPointContainer_FindConnectionPoint()" : Prnt ""
     #EndIf
  Else
     #If %Def(%DEBUG)
     Prnt "  Got Where I Shouldn't Have Gotten!!!"
     Prnt "  Leavinging IConnectionPointContainer_FindConnectionPoint()"
     #EndIf
     Function=%E_NOINTERFACE
  End If
End Function


Function IConnectionPoint_QueryInterface(ByVal this As IConnectionPoint1 Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "    Entering IConnectionPoint_QueryInterface()"
  #EndIf
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Decr this : Decr this
      @ppv=this
      Call IGrid_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IUnknown"
      Prnt "    Leaving IConnectionPoint_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IFHGrid
      Decr this : Decr this
      @ppv=this
      Call IGrid_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IFHGrid"
      Prnt "    Leaving IConnectionPoint_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IConnectionPointContainer
      Decr this
      @ppv=this
      Call IConnectionPointContainer_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IConnectionPointContainer"
      Prnt "    Leaving IConnectionPoint_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case $IID_IConnectionPoint
      @ppv=this
      Call IConnectionPoint_AddRef(this)
      #If %Def(%DEBUG)
      Prnt "      Looking For IID_IConnectionPoint"
      Prnt "    Leaving IConnectionPoint_QueryInterface()"
      #EndIf
      Function=%S_OK : Exit Function
    Case Else
      #If %Def(%DEBUG)
      Prnt "        Looking For Something I Ain't Got!"
      Prnt "      Leaving IConnectionPoint_QueryInterface()"
      #EndIf
  End Select

  Function=%E_NOINTERFACE
End Function


Function IConnectionPoint_AddRef(ByVal this As IConnectionPoint1 Ptr) As Long
  Local pGrid As CGrid Ptr

  #If %Def(%DEBUG)
  Prnt "      Entering IConnectionPoint_AddRef()"
  #EndIf
  Decr this : Decr this
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "        @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << Before"
  #EndIf
  Incr @pGrid.m_cRef
  #If %Def(%DEBUG)
  Prnt "        @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "  << After"
  Prnt "      Leaving IConnectionPoint_AddRef()"
  #EndIf

  Function=@pGrid.m_cRef
End Function


Function IConnectionPoint_Release(ByVal this As IConnectionPoint1 Ptr) As Long
  Local pGrid As CGrid Ptr
  Register i As Long

  #If %Def(%DEBUG)
  Prnt "  Entering IConnectionPoint_Release()"
  #EndIf
  Decr this : Decr this
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "    @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "    << Before"
  #EndIf
  Decr @pGrid.m_cRef
  If @pGrid.m_cRef=0 Then
     #If %Def(%DEBUG)
     For i=0 To %MAX_CONNECTIONS-1
       Prnt "    " & Str$(i) & "    " & Str$(Varptr(@pGrid.@pISink[i])) & "    " & Str$(@pGrid.@pISink[i])
     Next i
     #EndIf
     Call DestroyWindow(@pGrid.hWndCtrl)
     #If %Def(%DEBUG)
     Prnt "    @pGrid.m_cRef = 0 And Will Now Delete pGrid!"
     #EndIf
     Call CoTaskMemFree(Byval @pGrid.pISink)  ' Or, Less Insane ... Call CoTaskMemFree(Byval @pGrid.pISink)
     Call CoTaskMemFree(Byval this)           ' Or, Less Insane ... Call CoTaskMemFree(Byval this)
     Call InterlockedDecrement(g_lObjs)
     #If %Def(%DEBUG)
     Prnt "  Leaving IConnectionPoint_Release()"
     #EndIf
     Function=0
  Else
     #If %Def(%DEBUG)
     Prnt "    @pGrid.m_cRef = " & Str$(@pGrid.m_cRef) & "    << After"
     Prnt "  Leaving IConnectionPoint_Release()"
     #EndIf
     Function=@pGrid.m_cRef
  End If
End Function


Function IConnectionPoint_GetConnectionInterface(Byval this As Dword, Byref iid As Dword) As Long
  Function=%E_NOTIMPL
End Function


Function IConnectionPoint_GetConnectionPointContainer(Byval this As Dword, Byval ppCPC As Dword) As Long
  Function=%E_NOTIMPL
End Function


Function IConnectionPoint_Advise(Byval this As IConnectionPoint1 Ptr, Byval pUnkSink As Dword Ptr, Byval pdwCookie As Dword Ptr) As Long
  Local blnFoundOpenSlot As Long
  Local Vtbl,dwPtr As Dword Ptr
  Local pGrid As CGrid Ptr
  Register i As Long
  Local hr As Long

  #If %Def(%DEBUG)
  Prnt "  Entering IConnectionPoint_Advise()!  Grab Your Hardhat And Hang On Tight!"
  Prnt "    this               = " & Str$(this)
  #EndIf
  Decr this : Decr this
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "    pGrid              = " & Str$(pGrid)
  Prnt "    @pGrid.hControl    = " & Str$(@pGrid.hWndCtrl)
  Prnt "    pUnkSink           = " & Str$(pUnkSink)
  #EndIf
  Vtbl=@pUnkSink
  #If %Def(%DEBUG)
  Prnt "    Vtbl               = " & Str$(Vtbl)
  Prnt "    @Vtbl[0]           = " & Str$(@Vtbl[0])
  #EndIf
  Call Dword @Vtbl[0] Using ptrQueryInterface(pUnkSink,$IID_IFHGrid_Events,Varptr(dwPtr)) To hr
  #If %Def(%DEBUG)
  Prnt "    dwPtr              = " & Str$(dwPtr)
  #EndIf
  If SUCCEEDED(hr) Then
     #If %Def(%DEBUG)
     Prnt "    Call Dword Succeeded!"
     #EndIf
     For i=0 To %MAX_CONNECTIONS-1
       If @pGrid.@pISink[i]=0 Then
          blnFoundOpenSlot=%True
          #If %Def(%DEBUG)
          Prnt "   " & Str$(i) & "    " & Str$(Varptr(@pGrid.@pISink[i])) & "    " & Str$(@pGrid.@pISink[i]) & "  Found Open Slot!"
          #EndIf
          Exit For
       Else
          #If %Def(%DEBUG)
          Prnt "   " & Str$(i) & "    " & Str$(Varptr(@pGrid.@pISink[i])) & "    " & Str$(@pGrid.@pISink[i])
          #EndIf
       End If
     Next i
     If blnFoundOpenSlot Then
        #If %Def(%DEBUG)
        Prnt "    Will Be Able To Store Connection Point!"
        #EndIf
        @pGrid.@pISink[i]=dwPtr
        @pdwCookie=i
        hr=%S_Ok
     Else
        @pdwCookie=0
        hr=%CONNECT_E_ADVISELIMIT
     End If
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving IConnectionPoint_Advise() And Still In One Piece!" : Prnt ""
  #EndIf

  Function=hr
End Function


Function IConnectionPoint_Unadvise(Byval this As IConnectionPoint1 Ptr, Byval dwCookie As Dword) As Long
  Local Vtbl,dwPtr As Dword Ptr
  Local pGrid As CGrid Ptr
  Local iReturn As Long

  #If %Def(%DEBUG)
  Prnt "  Entering IConnectionPoint_Unadvise()"
  Prnt "    this            = " & Str$(this)
  Prnt "    dwCookie        = " & Str$(dwCookie)
  #EndIf
  Decr this : Decr this
  pGrid=this
  #If %Def(%DEBUG)
  Prnt "    @pGrid.hWndCtrl = " & Str$(@pGrid.hWndCtrl)
  #EndIf
  dwPtr=@pGrid.@pISink[dwCookie]
  Vtbl=@dwPtr
  #If %Def(%DEBUG)
  Prnt "    dwPtr           = " & Str$(dwPtr)
  #EndIf
  Call Dword @Vtbl[2] Using ptrRelease(dwPtr) To iReturn
  If SUCCEEDED(iReturn) Then
     @pGrid.@pISink[dwCookie]=0
     #If %Def(%DEBUG)
     Prnt "    IGrid_Events::Release() Succeeded!"
     #EndIf
  End If
  #If %Def(%DEBUG)
  Prnt "    Release() Returned " & Str$(iReturn)
  Prnt "  Leaving IConnectionPoint_Unadvise()" : Prnt ""
  #EndIf

  Function=%NOERROR
End Function


Function IConnectionPoint_EnumConnections(Byval this As Dword, Byval ppEnum As Dword) As Long
  Function=%E_NOTIMPL
End Function


Function IClassFactory_AddRef(ByVal this As IClassFactory1 Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "      Entering IClassFactory_AddRef()"
  #EndIf
  Call InterlockedIncrement(g_lObjs)
  #If %Def(%DEBUG)
  Prnt "        g_lObjs = " & Str$(g_lObjs)
  Prnt "      Leaving IClassFactory_AddRef()"
  #EndIf

  IClassFactory_AddRef=g_lObjs
End Function


Function IClassFactory_Release(ByVal this As IClassFactory1 Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "    Entering IClassFactory_Release()"
  #EndIf
  Call InterlockedDecrement(g_lObjs)
  #If %Def(%DEBUG)
  Prnt "      g_lObjs = " & Str$(g_lObjs)
  Prnt "    Leaving IClassFactory_Release()"
  #EndIf

  IClassFactory_Release=g_lObjs
End Function


Function IClassFactory_QueryInterface(ByVal this As IClassFactory1 Ptr, ByRef RefIID As Guid, ByVal pCF As Dword Ptr) As Long
  #If %Def(%DEBUG)
  Prnt "    Entering IClassFactory_QueryInterface()"
  #EndIf
  @pCF=0
  If RefIID=$IID_IUnknown Or RefIID=$IID_IClassFactory Then
     Call IClassFactory_AddRef(this)
     @pCF=this
     #If %Def(%DEBUG)
     Prnt "      this = " & Str$(this)
     Prnt "    Leaving IClassFactory_QueryInterface()"
     #EndIf
     Function=%NOERROR : Exit Function
  End If
  #If %Def(%DEBUG)
  Prnt "    Leaving IClassFactory_QueryInterface() Empty Handed!"
  #EndIf

  Function=%E_NoInterface
End Function


Function IClassFactory_CreateInstance(ByVal this As IClassFactory1 Ptr, ByVal pUnknown As Dword, ByRef RefIID As Guid, Byval ppv As Dword Ptr) As Long
  Local pIGrid As IGrid Ptr
  Local pGrid As CGrid Ptr
  Local hr As Long

  #If %Def(%DEBUG)
  Prnt "  Entering IClassFactory_CreateInstance()"
  #EndIf
  @ppv=%NULL
  If pUnknown Then
     hr=%CLASS_E_NOAGGREGATION
  Else
     pGrid=CoTaskMemAlloc(SizeOf(CGrid))
     #If %Def(%DEBUG)
     Prnt "    pGrid                      = " & Str$(pGrid)
     #EndIf
     If pGrid Then
        @pGrid.pISink=CoTaskMemAlloc(%MAX_CONNECTIONS * %SIZEOF_PTR)
        If @pGrid.pISink Then
           Poke Dword, @pGrid.pISink, 0, 0, 0, 0    'Call memset(Byval @pGrid.pISink,0,%MAX_CONNECTIONS*%SIZEOF_PTR)
           @pGrid.lpIGridVtbl = VarPtr(IGrid_Vtbl)
           @pGrid.lpICPCVtbl  = VarPtr(IConnPointContainer_Vtbl)
           @pGrid.lpICPVtbl   = Varptr(IConnPoint_Vtbl)
           #If %Def(%DEBUG)
           Prnt "    Varptr(@pGrid.lpIGridVtbl) = " & Str$(Varptr(@pGrid.lpIGridVtbl))
           Prnt "    Varptr(@pGrid.lpICPCVtbl)  = " & Str$(Varptr(@pGrid.lpICPCVtbl))
           Prnt "    Varptr(@pGrid.lpICPVtbl)   = " & Str$(Varptr(@pGrid.lpICPVtbl))
           Prnt "    @pGrid.pISink              = " & Str$(@pGrid.pISink)
           #EndIf
           @pGrid.m_cRef=0 : @pGrid.hWndCtrl=0
           pIGrid=pGrid
           #If %Def(%DEBUG)
           Prnt "    @ppv                       = " & Str$(@ppv) & "  << Before QueryInterface() Call"
           #EndIf
           hr= IGrid_QueryInterface(pIGrid,RefIID,ppv)
           #If %Def(%DEBUG)
           Prnt "    @ppv                       = " & Str$(@ppv) & "  << After QueryInterface() Call"
           #EndIf
           If SUCCEEDED(hr) Then
              Call InterlockedIncrement(g_lObjs)
           Else
              Call CoTaskMemFree(Byval pGrid)
           End If
        Else
           Call CoTaskMemFree(Byval pGrid)
           hr=%E_OutOfMemory
        End If
     Else
        hr=%E_OutOfMemory
     End If
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving IClassFactory_CreateInstance()"
  Prnt ""
  #EndIf

  IClassFactory_CreateInstance=hr
End Function


Function IClassFactory_LockServer(ByVal this As IClassFactory1 Ptr, Byval flock As Long) As Long
  If flock Then
     Call InterlockedIncrement(g_lLocks)
  Else
     Call InterlockedDecrement(g_lLocks)
  End If

  IClassFactory_LockServer=%NOERROR
End Function


Function DllCanUnloadNow Alias "DllCanUnloadNow" () Export As Long
  #If %Def(%DEBUG)
  Prnt "Entering DllCanUnloadNow()"
  #EndIf
  If g_lObjs = 0 And g_lLocks = 0 Then
     #If %Def(%DEBUG)
     Prnt "  I'm Outta Here! (dll is unloaded)"
     #EndIf
     Function=%S_OK
  Else
     #If %Def(%DEBUG)
     Prnt "  The System Wants Rid Of Me But I Won't Go!"
     #EndIf
     Function=%S_FALSE
  End If
  #If %Def(%DEBUG)
  Prnt "Leaving DllCanUnloadNow()"
  #EndIf
End Function


Function DllGetClassObjectImpl Alias "DllGetClassObject" (ByRef RefClsid As Guid, ByRef iid As Guid, ByVal pClassFactory As Dword Ptr) Export As Long
  Local hr As Long

  #If %Def(%DEBUG)
  Prnt "" : Prnt "  Entering DllGetClassObjectImpl()"
  #EndIf
  If RefClsid=$CLSID_FHGrid Then
     hr=IClassFactory_QueryInterface(VarPtr(CDClassFactory),iid,pClassFactory)
     If FAILED(hr) Then
        pClassFactory=0
        hr=%CLASS_E_CLASSNOTAVAILABLE
     Else
        Call Initialize()
        #If %Def(%DEBUG)
        Prnt "    IClassFactory_QueryInterface() For iid Succeeded!"
        #EndIf
     End If
  End If
  #If %Def(%DEBUG)
  Prnt "  Leaving DllGetClassObjectImpl()" : Prnt ""
  #EndIf

  Function=hr
End Function


Function SetKeyAndValue(Byref szKey As ZStr, Byref szSubKey As ZStr, Byref szValue As ZStr) As Long   'Original
  Local szKeyBuf As ZStr*1024
  Local lResult As Long
  Local hKey As Dword

  If szKey <> "" Then
     szKeyBuf = szKey
     If szSubKey <> "" Then
        szKeyBuf = szKeyBuf + "\" + szSubKey
     End If
     lResult=RegCreateKeyEx(%HKEY_CLASSES_ROOT, szKeyBuf, 0 ,Byval %NULL, %REG_OPTION_NON_VOLATILE, %KEY_ALL_ACCESS, Byval %NULL, hKey, %NULL)
     If lResult<>%ERROR_SUCCESS Then
        Function=%FALSE : Exit Function
     End If
     If szValue<>"" Then
        Call RegSetValueEx(hKey, Byval %NULL, Byval 0, %REG_SZ, szValue, Len(szValue) * %SIZEOF_CHAR + %SIZEOF_CHAR)
     End If
     Call RegCloseKey(hKey)
  Else
     Function=%FALSE : Exit Function
  End If

  Function=%TRUE
End Function


Function RecursiveDeleteKey(Byval hKeyParent As Dword, Byref lpszKeyChild As ZStr) As Long          'Original
  Local dwSize,hKeyChild As Dword
  Local szBuffer As ZStr*256
  Local time As FILETIME
  Local lRes As Long

  dwSize=256
  lRes=RegOpenKeyEx(hKeyParent,lpszKeyChild,0,%KEY_ALL_ACCESS,hKeyChild)
  If lRes<>%ERROR_SUCCESS Then
     Function=lRes
     Exit Function
  End If
  While(RegEnumKeyEx(hKeyChild, 0, szBuffer, dwSize, Byval 0, Byval 0, Byval 0, time)=%S_OK)
    lRes=RecursiveDeleteKey(hKeyChild,szBuffer)  'Delete the decendents of this child.
    If lRes<>%ERROR_SUCCESS Then
       Call RegCloseKey(hKeyChild)
       Function=lRes
       Exit Function
    End If
    dwSize=256
  Loop
  Call RegCloseKey(hKeyChild)

  Function=RegDeleteKey(hKeyParent,lpszKeyChild)  'Delete this child.
End Function


Function RegisterServer(Byref szFileName As ZStr, Byref ClassId As Guid, Byref LibId As Guid, Byref szFriendlyName As ZStr, Byref szVerIndProgID As ZStr, Byref szProgID As ZStr) As Long
  Local szClsid As ZStr*96, szLibid As ZStr*96, szKey As ZStr*128
  Local iReturn As Long

  #If %Def(%DEBUG)
  Print #fp, "    Entering RegisterServer()"
  Print #fp, "      szFileName      = " szFileName
  Print #fp, "      szFriendlyName  = " szFriendlyName
  Print #fp, "      szVerIndProgID  = " szVerIndProgID
  Print #fp, "      szProgID        = " szProgID
  #EndIf
  szClsid=GuidTxt$(ClassId)
  szLibid=GuidTxt$(LibId)
  #If %Def(%DEBUG)
  Print #fp, "      szClsid = " szClsid
  Print #fp, "      szLibid = " szLibid
  #EndIf
  If szClsid <> "" And szLibid <> "" Then
     szKey="CLSID\" & szClsid
     If IsFalse(SetKeyAndValue(szKey, Byval %NULL, szFriendlyName)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szFriendlyName = " szFriendlyName
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szKey, "InprocServer32", szFileName)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szFileName     = " szFileName
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szKey, "ProgID", szProgID)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szProgID       = " szProgID
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szKey, "VersionIndependentProgID", szVerIndProgID)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szVerIndProgID = " szVerIndProgID
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szKey, "TypeLib", szLibid)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szLibid        = " szLibid
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szVerIndProgID,Byval %NULL, szFriendlyName)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szVerIndProgID = " szVerIndProgID
        Print #fp, "      szFriendlyName = " szFriendlyName
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szVerIndProgID, "CLSID", szClsid)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szClsid        = " szClsid
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szVerIndProgID, "CurVer", szProgID)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szProgID       = " szProgID
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szProgID, Byval %NULL, szFriendlyName)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szFriendlyName = " szFriendlyName
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     If IsFalse(SetKeyAndValue(szProgID, "CLSID", szClsid)) Then
        #If %Def(%DEBUG)
        Print #fp, "      szClsid        = " szClsid
        Print #fp, "    Leaving RegisterServer() Early!"
        #EndIf
        Function=%E_FAIL : Exit Function
     End If
     #If %Def(%DEBUG)
     Print #fp, "      RegisterServer = %S_OK!
     Print #fp, "    Leaving RegisterServer()"
     #EndIf
     Function=%S_OK      : Exit Function
  Else
     #If %Def(%DEBUG)
     Print #fp, "      RegisterServer  = %E_FAIL!"
     Print #fp, "    Leaving RegisterServer() Early!"
     #EndIf
     Function=%E_FAIL    : Exit Function
  End If
End Function


Function UnregisterServer(Byref ClassId As Guid, Byref szVerIndProgID As ZStr, Byref szProgID As ZStr) As Long
  Local szClsid As ZStr*48, szKey As ZStr*64
  Local lResult As Long

  #If %Def(%DEBUG)
  Print #fp, "    Entering UnRegisterServer()"
  Print #fp, "      szVerIndProgID = " szVerIndProgID
  Print #fp, "      szProgID       = " szProgID
  #EndIf
  szClsid=GuidTxt$(ClassId)
  If szClsid<>"" Then
     szKey="CLSID\"+szClsid
     lResult=RecursiveDeleteKey(%HKEY_CLASSES_ROOT,szKey)
     If lResult<>%ERROR_SUCCESS Then
        #If %Def(%DEBUG)
        Print #fp, "    Got In Where RecursiveDeleteKey() Failed!"
        Print #fp, "  Leaving UnregisterServer()"
        #EndIf
        Function=%E_FAIL
        Exit Function
     End If
     lResult=RecursiveDeleteKey(%HKEY_CLASSES_ROOT, szVerIndProgID)    'Delete the version-independent ProgID Key.
     If lResult<>%ERROR_SUCCESS Then
        Function=%E_FAIL
        Exit Function
     End If
     lResult=recursiveDeleteKey(%HKEY_CLASSES_ROOT, szProgID)          'Delete the ProgID key.
     If lResult<>%ERROR_SUCCESS Then
        Function=%E_FAIL
        Exit Function
     End If
     #If %Def(%DEBUG)
     Print #fp, "    Leaving UnregisterServer()"
     #EndIf
  Else
     Function=%E_FAIL
     Exit Function
  End If

  Function=%S_OK
End Function


Function DllRegisterServer Alias "DllRegisterServer" () Export As Long
  Local szFriendlyName As ZStr*64, szVerIndProgID As ZStr*32, szProgID As ZStr*32
  Local strAsciPath,strWideCharPath,strPath As BStr
  Local hr,iBytesReturned As Long
  Local pTypeLib As Dword Ptr      ' For Jose's Includes use
  Local szPath As ZStr*256         ' Local pTypeLib As ITypeLib
  Local Vtbl As Dword Ptr          ' Don't need this for Jose's Incs

  #If %Def(%DEBUG)
  Print #fp, "  Entering DllRegisterServer()"
  #EndIf
  If GetModuleFileName(g_hModule, szPath, 256) Then
     #If %Def(%DEBUG)
     Print #fp, "    szPath = " szPath
     #EndIf
     #If %Def(%UNICODE)
         strWideCharPath=szPath
     #Else
         strAsciPath=szPath
         strWideCharPath=UCode$(strAsciPath & $Nul)
     #EndIf
     hr=LoadTypeLibEx(Byval Strptr(strWideCharPath), %REGKIND_REGISTER, pTypeLib)
     If SUCCEEDED(hr) Then
        #If %Def(%DEBUG)
        Print #fp, "    LoadTypeLib() Succeeded!"
        #EndIf
        Vtbl=@pTypeLib                                    ' For Jose's Incs, replace these two lines
        Call Dword @Vtbl[2] Using ptrRelease(pTypeLib)    ' with simply - Set pTypeLib = Nothing
        'Set pTypeLib=Nothing
        szFriendlyName  =  "Fred Harris Grid Control v9"
        szVerIndProgID  =  "FHGrid9.Grid"
        szProgID        =  "FHGrid9.Grid.1"
        #If %Def(%DEBUG)
        Print #fp, "    szFriendlyName = " szFriendlyName
        Print #fp, "    szVerIndProgID = " szVerIndProgID
        Print #fp, "    szProgID       = " szProgID
        #EndIf
        hr=RegisterServer(szPath, $CLSID_FHGrid, $IID_LIBID_FHGrid, szFriendlyName, szVerIndProgID, szProgID)
        #If %Def(%DEBUG)
        If SUCCEEDED(hr) Then
           Print #fp, "    RegisterServer() Succeeded!"
        Else
           Print #fp, "    RegisterServer() Failed!"
        End If
        #EndIf
     Else
        #If %Def(%DEBUG)
        Print #fp, "    LoadTypeLib() Failed!"
        #EndIf
     End If
  End If
  #If %Def(%DEBUG)
  Print #fp, "  Leaving DllRegisterServer()"
  #EndIf

  Function=hr
End Function


Function DllUnregisterServer Alias "DllUnregisterServer" () Export As Long
  Local szVerIndProgID As ZStr*32, szProgID As ZStr*32
  Local hr As Long

  #If %Def(%DEBUG)
  Print #fp, "  Entering DllUnrrgisterServer()"
  #EndIf
  hr=UnRegisterTypeLib($IID_LIBID_FHGrid, 1, 0, %LANG_NEUTRAL, %SYS_WIN32)
  If SUCCEEDED(hr) Then
     szVerIndProgID  =  "FHGrid9.Grid"
     szProgID        =  "FHGrid9.Grid.1"
     hr=UnregisterServer($CLSID_FHGrid, szVerIndProgID, szProgID)
     #If %Def(%DEBUG)
     Print #fp, "    Got In Where UnRegisterTypeLib() Succeeded!"
     #EndIf
  Else
     #If %Def(%DEBUG)
     Print #fp, "    Got In Where UnRegisterTypeLib() Failed!"
     #EndIf
  End If
  #If %Def(%DEBUG)
  Print #fp, "  Leaving DllUnrrgisterServer()"
  #EndIf

  Function=hr
End Function


Function DllMain(ByVal hInstance As Long, ByVal fwdReason As Long, ByVal lpvReserved As Long) Export As Long
  Select Case As Long fwdReason
    Case %DLL_PROCESS_ATTACH
      #If %Def(%DEBUG)
      Local iLastSlash As Long
      Local szPath As ZStr*256, szNewPath As ZStr*256
      If GetModuleFileName(hInstance, szPath, 256) Then
         iLastSlash=InStr(-1, szPath, "\"$$)
         If iLastSlash Then
            szNewPath=Left$(szPath,iLastSlash)+"Output.txt"$$
            fp=Freefile
            Open szNewPath For Output As #fp
            Print #fp, "Entering DllMain() -- %DLL_PROCESS_ATTACH"
            Print #fp, "  szPath     = " szPath
            Print #fp, "  iLastSlash = " iLastSlash
         End If
      End If
      #EndIf
      Call DisableThreadLibraryCalls(hInstance)
      g_hModule         =  hInstance
      g_CtrlId          =  1500

      IClassFactory_Vtbl.QueryInterface               = CodePtr(IClassFactory_QueryInterface)
      IClassFactory_Vtbl.AddRef                       = CodePtr(IClassFactory_AddRef)
      IClassFactory_Vtbl.Release                      = CodePtr(IClassFactory_Release)
      IClassFactory_Vtbl.CreateInstance               = CodePtr(IClassFactory_CreateInstance)
      IClassFactory_Vtbl.LockServer                   = CodePtr(IClassFactory_LockServer)
      CDClassFactory.lpVtbl                           = VarPtr(IClassFactory_Vtbl)

      IGrid_Vtbl.QueryInterface                       = CodePtr(IGrid_QueryInterface)
      IGrid_Vtbl.AddRef                               = CodePtr(IGrid_AddRef)
      IGrid_Vtbl.Release                              = CodePtr(IGrid_Release)
      IGrid_Vtbl.CreateGrid                           = CodePtr(IGrid_CreateGrid)
      IGrid_Vtbl.SetRowCount                          = CodePtr(IGrid_SetRowCount)
      IGrid_Vtbl.GetRowCount                          = CodePtr(IGrid_GetRowCount)
      IGrid_Vtbl.SetData                              = CodePtr(IGrid_SetData)
      IGrid_Vtbl.GetData                              = CodePtr(IGrid_GetData)
      IGrid_Vtbl.FlushData                            = CodePtr(IGrid_FlushData)
      IGrid_Vtbl.Refresh                              = CodePtr(IGrid_Refresh)
      IGrid_Vtbl.GetVisibleRows                       = CodePtr(IGrid_GetVisibleRows)
      IGrid_Vtbl.GethGrid                             = CodePtr(IGrid_GethGrid)
      IGrid_Vtbl.GethCell                             = CodePtr(IGrid_GethCell)
      IGrid_Vtbl.GethComboBox                         = CodePtr(IGrid_GethComboBox)
      IGrid_Vtbl.SetCellAttributes                    = CodePtr(IGrid_SetCellAttributes)
      IGrid_Vtbl.DeleteRow                            = Codeptr(IGrid_DeleteRow)

      IConnPointContainer_Vtbl.QueryInterface         = CodePtr(IConnectionPointContainer_QueryInterface)
      IConnPointContainer_Vtbl.AddRef                 = CodePtr(IConnectionPointContainer_AddRef)
      IConnPointContainer_Vtbl.Release                = CodePtr(IConnectionPointContainer_Release)
      IConnPointContainer_Vtbl.EnumConnectionPoints   = CodePtr(IConnectionPointContainer_EnumConnectionPoints)
      IConnPointContainer_Vtbl.FindConnectionPoint    = CodePtr(IConnectionPointContainer_FindConnectionPoint)

      IConnPoint_Vtbl.QueryInterface                  = CodePtr(IConnectionPoint_QueryInterface)
      IConnPoint_Vtbl.AddRef                          = CodePtr(IConnectionPoint_AddRef)
      IConnPoint_Vtbl.Release                         = CodePtr(IConnectionPoint_Release)
      IConnPoint_Vtbl.GetConnectionInterface          = CodePtr(IConnectionPoint_GetConnectionInterface)
      IConnPoint_Vtbl.GetConnectionPointContainer     = CodePtr(IConnectionPoint_GetConnectionPointContainer)
      IConnPoint_Vtbl.Advise                          = CodePtr(IConnectionPoint_Advise)
      IConnPoint_Vtbl.Unadvise                        = CodePtr(IConnectionPoint_Unadvise)
      IConnPoint_Vtbl.EnumConnections                 = CodePtr(IConnectionPoint_EnumConnections)
    Case %DLL_PROCESS_DETACH
      #If %Def(%DEBUG)
      Print #fp, "Leaving DllMain() -- %DLL_PROCESS_DETACH"
      Close #fp
      #EndIf
  End Select

  DllMain=%TRUE
End Function
